
// #name = Tribes 2 Graphic Selector
// #version = 1.00
// #date = June 14, 2002
// #author =Mark Dickenson ([AKA]PanamaJack)
// #email = akapanamajack@planettribes.com
// #web = http://www.planettribes.com/pj
// #description = Graphic Selector
// #acknowledgements = none
// #status = working

function PJViewerList::onSelect( %this, %id, %text ) {

	if(PJViewerList.state $= "background") {

		if(%id < 6) {
			$PJSelectedBitmap = "gui/" @ %text;
		} else {
			$PJSelectedBitmap = "panamajack/backgrounds/" @ %text;
		}
	} else {
               $PJSelectedBitmap = PJViewerList.path @ %text;
     }

	PJViewerDisplay.setBitmap($PJSelectedBitmap);

}

function PJbuildviewer() {

//--- OBJECT WRITE BEGIN ---
new GuiControl(PJGraphicViewer) {
	profile = "DlgBackProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	helpTag = "0";

	new ShellPaneCtrl(PJBackgroundTitle) {
		profile = "ShellDlgPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "134 64";
		extent = "372 280";
		minExtent = "48 92";
		visible = "0";
		helpTag = "0";
		text = "Set Background";
		noTitleBar = "0";

		new ShellBitmapButton(PJViewerCANCEL) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "57 225";
			extent = "128 38";
			minExtent = "32 38";
			visible = "1";
			command = "PJPopDialog(PJGraphicViewer, 2, 4, 7, 0, 0, 0, 1, PJSoundEffects.PJGraphicViewer1, PJSoundEffects.PJGraphicViewer1, 0, $PJPref::GeneralAnimationSpeed, 1);";
			helpTag = "0";
			text = "Cancel";
			simpleStyle = "0";
		};

		new ShellPopupMenu(PJViewerList) {
			profile = "ShellPopupProfile";
			horizSizing = "center";
			vertSizing = "top";
			position = "50 50";
			extent = "300 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Background Image";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};

		new ShellFieldCtrl() {
			profile = "ShellFieldProfile";
			horizSizing = "center";
			vertSizing = "top";
			position = "0 90";
			extent = "170 130";
			minExtent = "16 18";
			visible = "1";
			helpTag = "0";

			new GuiChunkedBitmapCtrl(PJViewerDisplay) {
				profile = "GuiDefaultProfile";
				horizSizing = "width";
				vertSizing = "height";
				position = "3 4";
				extent = "164 124";
				minExtent = "8 8";
				visible = "1";
				helpTag = "0";
				bitmap = $ShellBackground;
				useVariable = "0";
			};
		};

		new ShellBitmapButton(PJViewerOK) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "194 225";
			extent = "128 38";
			minExtent = "32 38";
			visible = "1";
			command = "PJPopDialog(PJGraphicViewer, 2, 4, 7, 0, 0, 0, 1, PJSoundEffects.PJGraphicViewer1, PJSoundEffects.PJGraphicViewer2, 0, $PJPref::GeneralAnimationSpeed, 1);";
			helpTag = "0";
			text = "Select";
			simpleStyle = "0";
		};
		new GuiMLTextCtrl(PJViewerText) {
			profile = "GuiFontProfile";
			horizSizing = "center";
			vertSizing = "top";
			position = "179 35";
			extent = "250 22";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
		};
	};
};
//--- OBJECT WRITE END ---
}

PJbuildviewer();
