
// #name = Tribes 2 Hud Mover
// #version = 7.06
// #date = April 10, 2003
// #author = Mark Dickenson ([AKA]PanamaJack)
// #email = akapanamajack@wildmail.com
// #web = http://www.planetstarsiege.com/pj
// #description = Move In Game Huds around
// #acknowledgements = Labrat for making an excellent Hud Mover that I use for everything else! (and I used bits and pieces of his code to build this because I needed special control)
// #status = work in progress

$PJVersion::HudMover = "7.06";

if(!isObject(PJOptionList))
    new ScriptObject(PJOptionList){};

PJOptionList.scriptcount++;
PJOptionList.guipath[PJOptionList.scriptcount] = "";
PJOptionList.enablevariable[PJOptionList.scriptcount] = "";
PJOptionList.selectcommand[PJOptionList.scriptcount] = "";
PJOptionList.listtext[PJOptionList.scriptcount] = "PJ's Hud Mover - " @ $PJVersion::HudMover;
PJOptionList.readmepath[PJOptionList.scriptcount] = "scripts/autoexec/panamajack/readme/hudmover.txt";
PJOptionList.activate[PJOptionList.scriptcount] = "";
PJOptionList.deactivate[PJOptionList.scriptcount] = "";
PJOptionList.preloadgui[PJOptionList.scriptcount] = 0;
PJOptionList.picturepath[PJOptionList.scriptcount] = "panamajack/scripts/hudmover.jpg";
PJOptionList.author[PJOptionList.scriptcount] = "Panama Jack";

new ScriptObject(PJHudmoverData){
     exclusionnavhud = 1;
     exclusionRetCenterHud = 1;
     exclusioncontrolObjectText = 1;
     exclusionZoomHud = 1;
     exclusionmetricsMain = 1;
     exclusionHelpTextGui = 1;
     exclusionSiegeHalftimeHud = 1;
     exclusionenergyHudb = 1;
     exclusiondamageHudb = 1;
     exclusionHeatHudb = 1;
     exclusionPJghosthud = 1;
     exclusionkGrenadeLauncherReticle = 1;
     exclusionkMortarReticle = 1;
     exclusion = 1;
     otherhudsbuilt = 0;
};

if(!isObject(PJPackageData))
    new ScriptObject(PJPackageData){};

function addpackage(%packagedfunction, %function, %beforeafter){

	PJPackageData.count[%packagedfunction @ %beforeafter]++;
	%temp = %packagedfunction @ %beforeafter @ PJPackageData.count[%packagedfunction @ %beforeafter];
	PJPackageData.funccall[%temp] = %function;
}

package PJPackageLoadmover {

function showChatMenuHud(){

     parent::showChatMenuHud();

	if($PJPref::LabratOverride) {
          if($PJSystemHudMoverchatMenuHud !$= "")
               chatMenuHud.position = $PJSystemHudMoverchatMenuHud;
     }
}

function hudmover::addhud(%name,%desc){

     parent::addhud(%name,%desc);

	if($PJPref::LabratOverride != 0) {
          if(%name !$= "hudmover"){
               if(!PJisHud2(%name)) {
                    $PJLabratHudCount++;
                    $PJLabratHudList[$PJLabratHudCount] = %name;
                    $PJLabratHudName[$PJLabratHudCount] = %desc;
                    if($PJLabratHudMover[%name] $= "")
                         $PJLabratHudMover[%name] = %name.position;

                    $PJLabratHudResize[%name] = 1;
               }
          }
     }
}

function clientCmdSetPilotVehicleKeys() { 

	parent::clientCmdSetPilotVehicleKeys(); 
	passengerKeys.copyBind(moveMap, PJHudInit); 
} 

function clientCmdSetPassengerVehicleKeys() { 

	parent::clientCmdSetPassengerVehicleKeys(); 
	passengerKeys.copyBind(moveMap, PJHudInit); 
}

};

activatepackage(PJPackageLoadmover);

addpackage("DispatchLaunchMode", "DispatchLaunchModeHudmover", "before");

function DispatchLaunchModeHudmover() {

	if(PJGlobalOption.startup != 1){
		exec("prefs/PJClientSchemes.cs");
		exec("prefs/PJClientPrefs.cs");
		exec("prefs/PJClientColors.cs");
		exec("prefs/PJClientFonts.cs");
		exec("prefs/PJScripts.cs");
		exec("scripts/autoexec/panamajack/PJGuiProfiles.pj");
		PJGlobalOption.startup = 1;
	}

	if($PJScript::SuperHuds){
		if($PJscheme::MainHudStyle $= "Normal" || $PJscheme::MainHudStyle $= "") {
			$PJGuiColor = "gui/";
		}else{
			$PJGuiColor = "schemes/" @ $PJscheme::MainHudStyle @ "/";
		}
	} else $PJGuiColor = "gui/";

	new GuiControlProfile ("PJMoverBackProfile"){
		bitmapbase = $PJGuiColor @ "hud_new_window";
	};

	new GuiControlProfile ("PJMoverProfile"){
		fontType = "Univers";
		fontSize = 16;
		fontColor = "169 215 250";
	};

	PJCheckforLabrat();
}

addpackage("LoadingGui::onWake", "PJAddSystemHuds", "before");
addpackage("OptionsDlg::onWake", "PJHudmoverRemap", "before");

addMessageCallback('MsgClientReady', PJclientready);

function PJclientready(%msgType, %msgString, %game){

	schedule(1000, 0, PJTR2HudMoverSetup);
	schedule(3000, 0, PJSetSystemHuds);
}

function PJTR2HudMoverSetup(){

	if($PJPref::TR2HudsMovable){
		if(isObject(TR2BonusHud))
			TR2BonusHud.horizSizing = "left";
		$TR2Pref::EventHud::DockToChat = false;
		if(isObject(TR2_ThrowStrength))
			TR2_ThrowStrength.horizSizing = "left";
	}
}

function PJHudmoverRemap(%this) {

	if($PJHudMovRemap !$= "true") {
		$RemapName[$RemapCount]="PJ Hud Mover";
		$RemapCmd[$RemapCount]="PJHudInit";
		$RemapCount++;
		$PJHudMovRemap = "true";
	}
}

function PJHudInit(%val) {
	if (%val){
		if(!isObject(movePJhudMap)) {
			PJEnableHudStuff();
		}
	}
}

function PJEnableHudStuff() {

	PJHudmoverData.arrowdelay = 700;
	new ActionMap( movePJEscapeMap );
	movePJEscapeMap.bindCmd( keyboard, "escape", "", "PJexithudmover();" );
	movePJEscapeMap.bindCmd( keyboard, "tab", "", "PJReloadHuds();" );
	movePJEscapeMap.bindCmd( keyboard, "space", "", "PJDefaultHuds();" );
	movePJEscapeMap.push();
	new ActionMap( movePJhudMap );
	movePJhudMap.bindCmd( keyboard, "escape", "", "PJResetHudMove();" );
	movePJhudMap.bindCmd( keyboard, "space", "", "PJsavehud();" );
	movePJhudMap.bindCmd( keyboard, "enter", "", "PJMoverResizeStart();" );
	movePJhudMap.bindCmd( keyboard, left, "PJHudMove(\"left\");", "PJHudStop();" );
	movePJhudMap.bindCmd( keyboard, right, "PJHudMove(\"right\");", "PJHudStop();" );
	movePJhudMap.bindCmd( keyboard, up, "PJHudMove(\"up\");", "PJHudStop();" );
	movePJhudMap.bindCmd( keyboard, down, "PJHudMove(\"down\");", "PJHudStop();" );
	CursorOn();
	$PJHudSelection = 0;
	$PJhudmoverorigpos = "0 0";
	makemoverhuds();
	HudMoverDlg.setvisible(true);
	HudMoverDlg.position = $PJHudMoverHudMoverDlg;
}

function PJReloadHuds() {

	PJClearHudStuff();

	PJGetHudPositions();

	schedule(500, 0, ClientCmdDisplayHuds);
	schedule(1000, 0, PJEnableHudStuff);
}

function PJResetHudMove() {

     Canvas.pushDialog(PJHudMoverDlg);
	movePJhudMap.pop();
	movePJEscapeMap.push();
	PJghosthud.setvisible(false);
	PJghostDefaulthud.setvisible(false);
	cancel($PJHudSchedule);
}

function PJClearHudStuff() {

	HudMoverDlg.setvisible(false);
	PJghosthud.setvisible(false);
	PJghostDefaulthud.setvisible(false);

	cancel($PJHudSchedule);
	CursorOff();
	movePJhudMap.pop();
	movePJhudMap.delete();
	movePJEscapeMap.pop();
	movePJEscapeMap.delete();
	globalactionmap.push();
	updateActionMaps();

	HudMoverDlg.delete();
	PJghosthud.delete();
	PJghostDefaulthud.delete();
}

function PJexithudmover() {

	schedule(1000, 0, PJTR2HudMoverSetup);

     Canvas.popDialog(PJHudMoverDlg);
     PJClearHudStuff();

	export("$PJHudFirstTime", "prefs/" @ $PJPref::DefaultHudFile, False);
	export("$PJHudMover*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJHudExtent*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJHudResize*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJHudMovable*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJHudVisible*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJHudGhost*", "prefs/" @ $PJPref::DefaultHudFile, True);

	export("$PJSystemHudMover*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJSystemHudExtent*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJSystemHudResize*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJSystemHudMoved*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJSystemHudMovable*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJSystemHudVisible*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJSystemHudGhost*", "prefs/" @ $PJPref::DefaultHudFile, True);

	export("$PJLabratHudMover*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJLabratHudExtent*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJLabratHudResize*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJLabratHudMovable*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJLabratHudVisible*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJLabratHudGhost*", "prefs/" @ $PJPref::DefaultHudFile, True);

	export("$PJOtherHudMover*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJOtherHudExtent*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJOtherHudResize*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJOtherHudMovable*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJOtherHudVisible*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJOtherHudGhost*", "prefs/" @ $PJPref::DefaultHudFile, True);

}

function PJMoverResizeStart() {

	$PJResizeToggle++;

     if($PJhudmoverorigtype) {
          PJghosthud.position = $PJhudmoverorigpos;
          PJghosthud.extent = $PJhudmoverorigext;
          $PJHudResize = 1;

	HudMoverText.setText("<just:center><color:00ff00>Resizing: <color:ffffff>"@PJHudmoverData.name@"\n<color:00ff00>SPACEBAR<color:ffffff>-<color:00dddd>Save, <color:00ff00>ESCAPE<color:ffffff>-<color:00dddd>Abort\n<color:00ff00>Arrow Keys<color:ffffff>-<color:00dddd>Micro Resize");
     }
}

function PJHudMove(%direction){

	cancel($PJHudSchedule);

	if($PJHudResize){
		%xextent = getword(PJghosthud.extent, 0);
		%yextent = getword(PJghosthud.extent, 1);

		if(%direction $= "left")
			%xextent--;
		if(%direction $= "right")
			%xextent++;
		if(%direction $= "up")
			%yextent--;
		if(%direction $= "down")
			%yextent++;

		if(%xextent > 10 && %yextent > 3) {
			PJghosthud.extent = %xextent SPC %yextent;
		}
	}else{
		%xpos = getWord(PJghosthud.position, 0);
		%ypos = getWord(PJghosthud.position, 1);

		if(%direction $= "left")
			%xpos--;
		if(%direction $= "right")
			%xpos++;
		if(%direction $= "up")
			%ypos--;
		if(%direction $= "down")
			%ypos++;

		PJghosthud.position = %xpos SPC %ypos;
	}

	$PJHudSchedule = schedule(PJHudmoverData.arrowdelay, 0, PJHudMove, %direction);
	PJHudmoverData.arrowdelay = 10;
}

function PJHudStop(){

	cancel($PJHudSchedule);
	PJHudmoverData.arrowdelay = 700;
}

function PJnexthud() {

	$PJhudmoverorigpos = PJHudmoverData.ID.position;
	$PJhudmoverorigext = PJHudmoverData.ID.extent;
	PJghosthud.position = PJHudmoverData.ID.position;
	PJghosthud.extent = PJHudmoverData.ID.extent;
	PJghosthud.setvisible(true);
	PJghosttext.extent = PJHudmoverData.ID.extent;

	PJghostDefaulthud.position = PJHudmoverData.ID.position;
	PJghostDefaulthud.extent = PJHudmoverData.ID.extent;
	PJghostDefaulthud.setvisible(true);

	if(getWord(PJHudmoverData.ID.extent, 0) > 10 && getWord(PJHudmoverData.ID.extent, 1))
		PJghosttext.setText("<just:center>" @ PJHudmoverData.name);

	if($PJhudmoverorigtype) {
		HudMoverText.setText("<just:center><color:00ff00>Moving: <color:ffffff>"@PJHudmoverData.name@"\n<color:00ff00>SPACEBAR<color:ffffff>-<color:00dddd>Save, <color:00ff00>ESCAPE<color:ffffff>-<color:00dddd>Abort\n<color:00ff00>Enter<color:ffffff>-<color:00dddd>Resize Hud, <color:00ff00>Arrow Keys<color:ffffff>-<color:00dddd>Micro Move/Resize");
	} else {
		HudMoverText.setText("<just:center><color:00ff00>Moving: <color:ffffff>"@PJHudmoverData.name@"\n<color:00ff00>SPACEBAR<color:ffffff>-<color:00dddd>Save, <color:00ff00>ESCAPE<color:ffffff>-<color:00dddd>Abort\n<color:00ff00>Arrow Keys<color:ffffff>-<color:00dddd>Micro Move");
	}

	if(PJHudmoverData.ghost != 1)
		PJHudmoverData.ghost = 0;

}

function PJsavehud() {

	movePJhudMap.pop();
	movePJEscapeMap.push();
	cancel($PJHudSchedule);
	PJghosthud.setvisible(false);
	PJghostDefaulthud.setvisible(false);

	if($PJhudType == 3) {
		HudMoverText.setText("<just:center><color:00ff00>Saved: <color:ffffff>"@PJHudmoverData.name @ "\n\n<color:00ff00>Escape<color:ffffff>-<color:00dddd>Exit Mover");
		%temp = PJHudmoverData.ID;
		if($PJHudResize)
			%temp.resize(getWord(PJghosthud.position, 0), getword(PJghosthud.position, 1), getword(PJghosthud.extent, 0), getword(PJghosthud.extent, 1));
		%temp.position = PJghosthud.position;
		%temp.extent = PJghosthud.extent;
		$PJOtherHudMover[%temp] = %temp.position;
		$PJOtherHudExtent[%temp] = %temp.extent;
		$PJhudmoverorigpos = $PJOtherHudMover[%temp];
		$PJhudmoverorigext = $PJOtherHudExtent[%temp];
		$PJhudmoverorigtype = $PJOtherHudResize[%temp];
	}
	if($PJhudType == 2) {
		HudMoverText.setText("<just:center><color:00ff00>Saved: <color:ffffff>"@PJHudmoverData.name @ "\n\n<color:00ff00>Escape<color:ffffff>-<color:00dddd>Exit Mover");
		%temp = PJHudmoverData.ID;
		if($PJHudResize)
			%temp.resize(getWord(PJghosthud.position, 0), getword(PJghosthud.position, 1), getword(PJghosthud.extent, 0), getword(PJghosthud.extent, 1));
		%temp.position = PJghosthud.position;
		%temp.extent = PJghosthud.extent;
		$PJLabratHudMover[%temp] = %temp.position;
		$PJLabratHudExtent[%temp] = %temp.extent;
		$PJhudmoverorigpos = $PJLabratHudMover[%temp];
		$PJhudmoverorigext = $PJLabratHudExtent[%temp];
		$PJhudmoverorigtype = $PJLabratHudResize[%temp];
	}
	if($PJhudType == 1) {
		HudMoverText.setText("<just:center><color:00ff00>Saved: <color:ffffff>"@PJHudmoverData.name @ "\n\n<color:00ff00>Escape<color:ffffff>-<color:00dddd>Exit Mover");
		%temp = PJHudmoverData.ID;
		if($PJHudResize){
			if(%temp $= HeatHud || %temp $= damageHud || %temp $= energyHud){
				%temp.minExtent = PJghosthud.extent;
				%temp.subRegion = "0 0 " @ PJghosthud.extent;
			}
			%temp.resize(getWord(PJghosthud.position, 0), getword(PJghosthud.position, 1), getword(PJghosthud.extent, 0), getword(PJghosthud.extent, 1));
		}
		%temp.position = PJghosthud.position;
		%temp.extent = PJghosthud.extent;
		$PJSystemHudMover[%temp] = %temp.position;
		$PJSystemHudExtent[%temp] = %temp.extent;
		$PJhudmoverorigpos = $PJSystemHudMover[%temp];
		$PJhudmoverorigext = $PJSystemHudExtent[%temp];
		$PJhudmoverorigtype = $PJSystemHudResize[%temp];
	}
	if($PJhudType == 0){
		HudMoverText.setText("<just:center><color:00ff00>Saved: <color:ffffff>"@PJHudmoverData.name@ "\n\n<color:00ff00>Escape<color:ffffff>-<color:00dddd>Exit Mover");
		%temp = PJHudmoverData.ID;
		if($PJHudResize){
			%temp.resize(getWord(PJghosthud.position, 0), getword(PJghosthud.position, 1), getword(PJghosthud.extent, 0), getword(PJghosthud.extent, 1));
		}
		%temp.position = PJghosthud.position;
		%temp.extent = PJghosthud.extent;
		if(%temp !$= "TeamHud"){
     			$PJHudMover[%temp] = %temp.position;
		} else {
			$PJTeamHUD::PositionX = getword(%temp.position, 0);
			$PJTeamHUD::PositionY = getword(%temp.position, 1);
     			$PJHudMover[%temp] = $PJTeamHUD::PositionX @ " " @ $PJTeamHUD::PositionY;
		}

		if(%temp $= "PJCommandHud"){
     			CommanderMap.extent = getword(%temp.extent, 0) - 6 SPC getword(%temp.extent, 1) - 6;
		}

		$PJHudExtent[%temp] = %temp.extent;
		$PJhudmoverorigpos = $PJHudMover[%temp];
		$PJhudmoverorigext = $PJHudExtent[%temp];
		$PJhudmoverorigtype = $PJHudResize[%temp];
	}

	$PJHudResize = 0;

	canvas.pushdialog(PJHudMoverDlg);
}

function PJPopMaps(%global) {

	if (isObject(moveMap))
		moveMap.pop();
	if (isObject(passengerKeys))
		passengerKeys.pop();
	if ( isObject( observerBlockMap ) )
		observerBlockMap.pop();
	if ( isObject( observerMap ) )
		observerMap.pop();
	if (isObject(ControlActionMap))
		ControlActionMap.pop();
	if(%global)
		globalactionmap.pop();

}

function HM_PJHudList::onSelect( %this, %id, %text ){

	PJHudmoverData.ID2 = %id;
	PJHudmoverData.ID = $PJHudList[%id];
	$PJhudType = 0;
	PJHudmoverData.name = $PJHudName[%id];
	PJHudmoverData.ghost = $PJHudGhost[PJHudmoverData.ID];
	$PJhudmoverorigtype = $PJHudResize[PJHudmoverData.ID];
}

function HM_SystemHudList::onSelect( %this, %id, %text ){

	PJHudmoverData.ID2 = %id;
	PJHudmoverData.ID = $PJSystemHudList[%id];
	$PJhudType = 1;
	PJHudmoverData.name = $PJSystemHudName[%id];
	PJHudmoverData.ghost = $PJSystemHudGhost[PJHudmoverData.ID];
	$PJhudmoverorigtype = $PJSystemHudResize[PJHudmoverData.ID];
}

function HM_LabratHudList::onSelect( %this, %id, %text ){

	PJHudmoverData.ID2 = %id;
	PJHudmoverData.ID = $PJLabratHudList[%id];
	$PJhudType = 2;
	PJHudmoverData.name = $PJLabratHudName[%id];
	PJHudmoverData.ghost = $PJLabratHudGhost[PJHudmoverData.ID];
	$PJhudmoverorigtype = $PJLabratHudResize[PJHudmoverData.ID];
}

function HM_OtherHudList::onSelect( %this, %id, %text ){

	PJHudmoverData.ID2 = %id;
	PJHudmoverData.ID = $PJOtherHudList[%id];
	$PJhudType = 3;
	PJHudmoverData.name = $PJOtherHudName[%id];
	PJHudmoverData.ghost = $PJOtherHudGhost[PJHudmoverData.ID];
	$PJhudmoverorigtype = $PJOtherHudResize[PJHudmoverData.ID];
}

function HM_HudListonDblClick(){

	canvas.popdialog(PJHudMoverDlg);
	PJPopMaps( 1 );
	movePJEscapeMap.pop();
	movePJhudMap.push();
	CursorOn();
	PJnexthud();
}

function PJHudMoverDlg::onWake( %this ){

	PJHudMoverTitle.setValue(getSubStr(filebase($PJPref::DefaultHudFile), 6, 100) @ " Loaded");
   HM_PJHudPane.setVisible( false ); 
   HM_SystemHudPane.setVisible( false );
   HM_LabratHudPane.setVisible( false );
   HM_PJHudTab.setValue( false ); 
   HM_SystemHudTab.setValue( false );
   HM_LabratHudTab.setValue( false );
   HM_OtherHudTab.setValue( false );

   %this.setPane( %this.pane );
}

//------------------------------------------------------------------------------
function PJHudMoverDlg::setPane( %this, %pane ){

   if ( %this.pane !$= "None" )
   {
      %paneCtrl = "HM_" @ %this.pane @ "Pane";
      %paneCtrl.setVisible( false );

      %tabCtrl = "HM_" @ %this.pane @ "Tab";
      %tabCtrl.setValue( false );
   }
      
   %paneCtrl = "HM_" @ %pane @ "Pane";
   %paneCtrl.setVisible( true );
   
   %tabCtrl = "HM_" @ %pane @ "Tab";
   %tabCtrl.setValue( true );
   
   %this.pane = %pane; 
}

//------------------------------------------------------------------------------

function makemoverhuds() {

     canvas.pushdialog(PJHudMoverDlg);

	new ShellFieldCtrl(HudMoverDlg) {
		profile = "PJMoverBackProfile";
		horizSizing = "left";
		vertSizing = "top";
		position = "300 342";
		extent = "250 66";
		minExtent = "16 18";
		visible = "1";
		helpTag = "0";

		new GuiMLTextCtrl(HudMoverText) {
			profile = "PJMoverProfile";
			horizSizing = "left";
			vertSizing = "top";
			position = "0 0";
			extent = "246 64";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			lineSpacing = "2";
			allowColorChars = "0";
			maxChars = "-1";
		};
	};

	playgui.add(HudMoverDlg);

	HudMoverText.setText("<just:center><color:00ff00>Moving: <color:ffffff>Nothing Yet\n<color:00ff00>LMouse<color:ffffff>-<color:00dddd>Save, <color:00ff00>RMouse<color:ffffff>-<color:00dddd>Abort\n<color:00ff00>Escape<color:ffffff>-<color:00dddd>Exit Mover\n<color:00ff00>Space<color:ffffff>-<color:00dddd>Restore Huds");

	new ShellFieldCtrl(PJghosthud) {
		profile = "PJMoverBackProfile";
		horizSizing = "left";
		vertSizing = "top";
		position = "0 0";
		extent = "10 10";
		minExtent = "0 0";
		visible = "0";
		helpTag = "0";

		new GuiMLTextCtrl(PJghosttext) {
			profile = "PJMoverProfile";
			horizSizing = "width";
			vertSizing = "height";
			position = "0 0";
			extent = "80 18";
			minExtent = "0 0";
			visible = "1";
			helpTag = "0";
			lineSpacing = "2";
			allowColorChars = "0";
			maxChars = "-1";
		};
	};

	playgui.add(PJghosthud);

	new ShellFieldCtrl(PJghostDefaulthud) {
		profile = "PJMoverBackProfile";
		horizSizing = "left";
		vertSizing = "top";
		position = "0 0";
		extent = "10 10";
		minExtent = "0 0";
		visible = "0";
		helpTag = "0";

		new GuiMLTextCtrl(PJghostdefaulttext) {
			profile = "PJMoverProfile";
			horizSizing = "width";
			vertSizing = "height";
			position = "0 0";
			extent = "80 18";
			minExtent = "0 0";
			visible = "1";
			helpTag = "0";
			lineSpacing = "2";
			allowColorChars = "0";
			maxChars = "-1";
		};
	};

	playgui.add(PJghostDefaulthud);

	PJghostdefaulttext.setValue("Old Hud Position");

	HM_PJHudList.clear();
	HM_SystemHudList.clear();
	HM_LabratHudList.clear();
	HM_OtherHudList.clear();

	for(%i = 1; %i <= $PJHudCount; %i++) {

		%temp = $PJHudList[%i];

		%resize = $PJHudResize[%temp] == 1 ? "Y" : "N";
		%move = $PJHudMovable[%temp] == 0 ? "Y" : "N";
		%visible = $PJHudVisible[%temp] == 0 ? "Y" : "N";
		%ghost = $PJHudGhost[%temp] == 0 ? "Y" : "N";

   		HM_PJHudList.addrow( %i, $PJHudName[%i] TAB %resize TAB %move TAB %visible TAB %ghost);
	}

	HM_PJHudList.sort(increasing);
	HM_PJHudList.setSelectedRow(0);

	for(%i = 1; %i <= $PJSystemHudCount; %i++) {

		%temp = $PJSystemHudList[%i];

		%resize = $PJSystemHudResize[%temp] == 1 ? "Y" : "N";
		%move = $PJSystemHudMovable[%temp] == 0 ? "Y" : "N";
		%visible = $PJSystemHudVisible[%temp] == 0 ? "Y" : "N";
		%ghost = $PJSystemHudGhost[%temp] == 0 ? "Y" : "N";

    		HM_SystemHudList.addrow( %i, $PJSystemHudName[%i] TAB %resize TAB %move TAB %visible TAB %ghost);
	}

	HM_SystemHudList.sort(increasing);
	HM_SystemHudList.setSelectedRow(0);

	for(%i = 1; %i <= $PJLabratHudCount; %i++) {

		%temp = $PJLabratHudList[%i];

		%resize = $PJLabratHudResize[%temp] == 1 ? "Y" : "N";
		%move = $PJLabratHudMovable[%temp] == 0 ? "Y" : "N";
		%visible = $PJLabratHudVisible[%temp] == 0 ? "Y" : "N";
		%ghost = $PJLabratHudGhost[%temp] == 0 ? "Y" : "N";

    		HM_LabratHudList.addrow( %i, $PJLabratHudName[%i] TAB %resize TAB %move TAB %visible TAB %ghost);
	}

	HM_LabratHudList.sort(increasing);
	HM_LabratHudList.setSelectedRow(0);

     PJBuildOtherHudList();

	for(%i = 1; %i <= $PJOtherHudCount; %i++) {

		%temp = $PJOtherHudList[%i];

		%resize = $PJOtherHudResize[%temp] == 1 ? "Y" : "N";
		%move = $PJOtherHudMovable[%temp] == 0 ? "Y" : "N";
		%visible = $PJOtherHudVisible[%temp] == 0 ? "Y" : "N";
		%ghost = $PJOtherHudGhost[%temp] == 0 ? "Y" : "N";

    		HM_OtherHudList.addrow( %i, $PJOtherHudName[%i] TAB %resize TAB %move TAB %visible TAB %ghost);
	}

	HM_OtherHudList.sort(increasing);
	HM_OtherHudList.setSelectedRow(0);
}

function HM_PJHudList::onRightMouseDown( %this, %column, %row, %mousePos ){

	PJHudmoverData.popupname = getField(HM_PJHudList.getRowText(%row),0);
	PJHudmoverData.resize = getField(HM_PJHudList.getRowText(%row),1);
	PJHudmoverData.movable = getField(HM_PJHudList.getRowText(%row),2);
	PJHudmoverData.visible = getField(HM_PJHudList.getRowText(%row),3);
	PJHudmoverData.ghost = getField(HM_PJHudList.getRowText(%row),4);
	PJHudmoverData.row = %row;
	PJHudmoverData.listtype = 0;

	HM_PJHudList.setSelectedRow(%row);
	HudMousePopup.position = %mousePos;
	Canvas.pushDialog(HudMousePopupDLG);
	HudMousePopupDLG.onWake();
	HudMousePopup.forceOnAction();
	PJHudmoverData.list = $PJHudList[PJHudmoverData.ID2];
}

function HM_SystemHudList::onRightMouseDown( %this, %column, %row, %mousePos ){

	PJHudmoverData.popupname = getField(HM_SystemHudList.getRowText(%row),0);
	PJHudmoverData.resize = getField(HM_SystemHudList.getRowText(%row),1);
	PJHudmoverData.movable = getField(HM_SystemHudList.getRowText(%row),2);
	PJHudmoverData.visible = getField(HM_SystemHudList.getRowText(%row),3);
	PJHudmoverData.ghost = getField(HM_SystemHudList.getRowText(%row),4);
	PJHudmoverData.row = %row;
	PJHudmoverData.listtype = 1;

	HM_SystemHudList.setSelectedRow(%row);
	HudMousePopup.position = %mousePos;
	Canvas.pushDialog(HudMousePopupDLG);
	HudMousePopupDLG.onWake();
	HudMousePopup.forceOnAction();
	PJHudmoverData.list = $PJSystemHudList[PJHudmoverData.ID2];
}

function HM_LabratHudList::onRightMouseDown( %this, %column, %row, %mousePos ){

	PJHudmoverData.popupname = getField(HM_LabratHudList.getRowText(%row),0);
	PJHudmoverData.resize = getField(HM_LabratHudList.getRowText(%row),1);
	PJHudmoverData.movable = getField(HM_LabratHudList.getRowText(%row),2);
	PJHudmoverData.visible = getField(HM_LabratHudList.getRowText(%row),3);
	PJHudmoverData.ghost = getField(HM_LabratHudList.getRowText(%row),4);
	PJHudmoverData.row = %row;
	PJHudmoverData.listtype = 2;

	HM_LabratHudList.setSelectedRow(%row);
	HudMousePopup.position = %mousePos;
	Canvas.pushDialog(HudMousePopupDLG);
	HudMousePopupDLG.onWake();
	HudMousePopup.forceOnAction();
	PJHudmoverData.list = $PJHudList[PJHudmoverData.ID2];
}

function HM_OtherHudList::onRightMouseDown( %this, %column, %row, %mousePos ){

	PJHudmoverData.popupname = getField(HM_OtherHudList.getRowText(%row),0);
	PJHudmoverData.resize = getField(HM_OtherHudList.getRowText(%row),1);
	PJHudmoverData.movable = getField(HM_OtherHudList.getRowText(%row),2);
	PJHudmoverData.visible = getField(HM_OtherHudList.getRowText(%row),3);
	PJHudmoverData.ghost = getField(HM_OtherHudList.getRowText(%row),4);
	PJHudmoverData.row = %row;
	PJHudmoverData.listtype = 3;

	HM_OtherHudList.setSelectedRow(%row);
	HudMousePopup.position = %mousePos;
	Canvas.pushDialog(HudMousePopupDLG);
	HudMousePopupDLG.onWake();
	HudMousePopup.forceOnAction();
	PJHudmoverData.list = $PJHudList[PJHudmoverData.ID2];
}

function HudMousePopupDLG::onWake( %this ){

	HudMousePopup.clear();

	HudMousePopup.add( strupr(PJHudmoverData.popupname), -1);
	HudMousePopup.add( "---------------------------------------------", -1);
	HudMousePopup.add( "Change Moveable Status", 0 );
	HudMousePopup.add( "Change Visible Status", 1 );
	HudMousePopup.add( "Change Ghost Status", 2 );

}

function HudMousePopup::onSelect( %this, %id, %text ){

	switch( %id ){
		case 0: 
			if(PJHudmoverData.listtype == 0){

				%hud = PJHudmoverData.list;
				$PJHudMovable[%hud] = 1 - $PJHudMovable[%hud];

				%move = $PJHudMovable[%hud] == 0 ? "Y" : "N";

				HM_PJHudList.setRowById(PJHudmoverData.ID2, PJHudmoverData.popupname TAB PJHudmoverData.resize TAB %move TAB PJHudmoverData.visible TAB PJHudmoverData.ghost);
			}

			if(PJHudmoverData.listtype == 1){

				%hud = PJHudmoverData.list;
				$PJSystemHudMovable[%hud] = 1 - $PJSystemHudMovable[%hud];

				%move = $PJSystemHudMovable[%hud] == 0 ? "Y" : "N";

				HM_SystemHudList.setRowById(PJHudmoverData.ID2, PJHudmoverData.popupname TAB PJHudmoverData.resize TAB %move TAB PJHudmoverData.visible TAB PJHudmoverData.ghost);
			}

			if(PJHudmoverData.listtype == 2){

				%hud = PJHudmoverData.list;
				$PJLabratHudMovable[%hud] = 1 - $PJLabratHudMovable[%hud];

				%move = $PJLabratHudMovable[%hud] == 0 ? "Y" : "N";

				HM_LabratHudList.setRowById(PJHudmoverData.ID2, PJHudmoverData.popupname TAB PJHudmoverData.resize TAB %move TAB PJHudmoverData.visible TAB PJHudmoverData.ghost);
			}

			if(PJHudmoverData.listtype == 3){

				%hud = PJHudmoverData.list;
				$PJOtherHudMovable[%hud] = 1 - $PJOtherHudMovable[%hud];

				%move = $PJOtherHudMovable[%hud] == 0 ? "Y" : "N";

				HM_OtherHudList.setRowById(PJHudmoverData.ID2, PJHudmoverData.popupname TAB PJHudmoverData.resize TAB %move TAB PJHudmoverData.visible TAB PJHudmoverData.ghost);
			}

		case 1: 
			if(PJHudmoverData.listtype == 0){

				%hud = PJHudmoverData.list;
				$PJHudVisible[%hud] = 1 - $PJHudVisible[%hud];

				%visible = $PJHudVisible[%hud] == 0 ? "Y" : "N";

				HM_PJHudList.setRowById(PJHudmoverData.ID2, PJHudmoverData.popupname TAB PJHudmoverData.resize TAB PJHudmoverData.movable TAB %visible TAB PJHudmoverData.ghost);
			}

			if(PJHudmoverData.listtype == 1){

				%hud = PJHudmoverData.list;
				$PJSystemHudVisible[%hud] = 1 - $PJSystemHudVisible[%hud];

				%visible = $PJSystemHudVisible[%hud] == 0 ? "Y" : "N";

				HM_SystemHudList.setRowById(PJHudmoverData.ID2, PJHudmoverData.popupname TAB PJHudmoverData.resize TAB PJHudmoverData.movable TAB %visible TAB PJHudmoverData.ghost);
			}

			if(PJHudmoverData.listtype == 2){

				%hud = PJHudmoverData.list;
				$PJLabratHudVisible[%hud] = 1 - $PJLabratHudVisible[%hud];

				%visible = $PJLabratHudVisible[%hud] == 0 ? "Y" : "N";

				HM_LabratHudList.setRowById(PJHudmoverData.ID2, PJHudmoverData.popupname TAB PJHudmoverData.resize TAB PJHudmoverData.movable TAB %visible TAB PJHudmoverData.ghost);
			}

			if(PJHudmoverData.listtype == 3){

				%hud = PJHudmoverData.list;
				$PJOtherHudVisible[%hud] = 1 - $PJOtherHudVisible[%hud];

				%visible = $PJOtherHudVisible[%hud] == 0 ? "Y" : "N";

				HM_OtherHudList.setRowById(PJHudmoverData.ID2, PJHudmoverData.popupname TAB PJHudmoverData.resize TAB PJHudmoverData.movable TAB %visible TAB PJHudmoverData.ghost);
			}

		case 2: 
			if(PJHudmoverData.listtype == 0){

				%hud = PJHudmoverData.list;
				$PJHudGhost[%hud] = 1 - $PJHudGhost[%hud];

				%ghost = $PJHudGhost[%hud] == 0 ? "Y" : "N";

				HM_PJHudList.setRowById(PJHudmoverData.ID2, PJHudmoverData.popupname TAB PJHudmoverData.resize TAB PJHudmoverData.movable TAB PJHudmoverData.visible TAB %ghost);
			}

			if(PJHudmoverData.listtype == 1){

				%hud = PJHudmoverData.list;
				$PJSystemHudGhost[%hud] = 1 - $PJSystemHudGhost[%hud];

				%ghost = $PJSystemHudGhost[%hud] == 0 ? "Y" : "N";

				HM_SystemHudList.setRowById(PJHudmoverData.ID2, PJHudmoverData.popupname TAB PJHudmoverData.resize TAB PJHudmoverData.movable TAB PJHudmoverData.visible TAB %ghost);
			}

			if(PJHudmoverData.listtype == 2){

				%hud = PJHudmoverData.list;
				$PJLabratHudGhost[%hud] = 1 - $PJLabratHudGhost[%hud];

				%ghost = $PJLabratHudGhost[%hud] == 0 ? "Y" : "N";

				HM_LabratHudList.setRowById(PJHudmoverData.ID2, PJHudmoverData.popupname TAB PJHudmoverData.resize TAB PJHudmoverData.movable TAB PJHudmoverData.visible TAB %ghost);
			}

			if(PJHudmoverData.listtype == 3){

				%hud = PJHudmoverData.list;
				$PJOtherHudGhost[%hud] = 1 - $PJOtherHudGhost[%hud];

				%ghost = $PJOtherHudGhost[%hud] == 0 ? "Y" : "N";

				HM_OtherHudList.setRowById(PJHudmoverData.ID2, PJHudmoverData.popupname TAB PJHudmoverData.resize TAB PJHudmoverData.movable TAB PJHudmoverData.visible TAB %ghost);
			}
	}

	canvas.PopDialog(HudMousePopupDLG);
}

function HudMousePopup::onSleep(%this){

}


function PJSetSystemHuds() {

	if($PJPref::LabratOverride) {
		for(%i = 1; %i <= $PJSystemHudCount; %i++) {
			//is this a docked system hud to the team hud
		          	if(!$PJPref::TeamHudSide && $PJPref::TeamDockSystem && $PJEnable::TeamHud && ($PJSystemHudList[%i] $= "objectiveHud" || $PJSystemHudList[%i] $= "inventoryHud" || $PJSystemHudList[%i] $= "backpackFrame" || $PJSystemHudList[%i] $= "weaponsHud")) {
			                    %temp = getWord($PJSystemHudList[%i].extent, 1);
			                    if($PJSystemHudMoved[$PJSystemHudList[%i]] == 1 && $PJSystemHudMovable[$PJSystemHudList[%i]] != 1)
		              			$PJSystemHudList[%i].position = getword($PJSystemHudMover[$PJSystemHudList[%i]], 0) SPC $PJTeamHUDDocked - %temp;
			} else {
				//not a docked hud or docking off
				if($PJSystemHudMoved[$PJSystemHudList[%i]] == 1 && $PJSystemHudMovable[$PJSystemHudList[%i]] != 1){
		              			$PJSystemHudList[%i].position = $PJSystemHudMover[$PJSystemHudList[%i]];
					if($PJSystemHudResize[$PJSystemHudList[%i]] == 1)
			              			$PJSystemHudList[%i].extent = $PJSystemHudextent[$PJSystemHudList[%i]];
				}
		               }
			if($PJSystemHudVisible[$PJSystemHudList[%i]] == 1)
				$PJSystemHudList[%i].setVisible(0);
		}

		if($PJLabratHudCount > 0) {
			for(%i=1; %i <= $PJLabratHudCount; %i++){
				if(isObject($PJLabratHudList[%i]) && $PJLabratHudMovable[$PJLabratHudList[%i]] != 1){
					$PJLabratHudList[%i].position = $PJLabratHudMover[$PJLabratHudList[%i]];
					$PJLabratHudList[%i].extent = $PJLabratHudExtent[$PJLabratHudList[%i]];
				}
				if($PJLabratHudVisible[$PJLabratHudList[%i]] == 1)
					$PJLabratHudList[%i].setVisible(0);
			}
		}

		if(!PJHudmoverData.otherhudsbuilt)
			PJBuildOtherHudList();

		if($PJOtherHudCount > 0) {
			for(%i=1; %i <= $PJOtherHudCount; %i++){
				if($PJOtherHudMover[$PJOtherHudList[%i]] !$= ""){
					if(isObject($PJOtherHudList[%i]) && $PJOtherHudMovable[$PJOtherHudList[%i]] != 1){
						$PJOtherHudList[%i].position = $PJOtherHudMover[$PJOtherHudList[%i]];
						$PJOtherHudList[%i].extent = $PJOtherHudExtent[$PJOtherHudList[%i]];
					}
				}
				if($PJOtherHudVisible[$PJOtherHudList[%i]] == 1)
					$PJOtherHudList[%i].setVisible(0);
			}
		}
	}

	if($PJHudCount > 0) {
		for(%i=1; %i <= $PJHudCount; %i++){
//error(isObject($PJHudList[%i] @" - "@$PJHudList[%i]);
//error($PJHudMover[$PJHudList[%i]]);
//error($PJHudVisible[$PJHudList[%i]]);
			if(isObject($PJHudList[%i]) && $PJHudMovable[$PJHudList[%i]] != 1){
				$PJHudList[%i].position = $PJHudMover[$PJHudList[%i]];
				if($PJHudResize[$PJHudList[%i]] == 1)
					$PJHudList[%i].extent = $PJHudExtent[$PJHudList[%i]];
			}
			if($PJHudVisible[$PJHudList[%i]] == 1)
				$PJHudList[%i].setVisible(0);
		}
	}
}

function PJAddSystemHuds(%this) {

	if($PJPref::LabratOverride == 0) {
		return;
	}

	addToSystemHudlist("objectiveHud", "T2 Objective Hud", 0);
	addToSystemHudlist("chatMenuHud", "T2 Voice Chat Menu", 0);
	addToSystemHudlist("inventoryHud", "T2 Inventory Hud", 0);
	addToSystemHudlist("backpackFrame", "T2 Pack Hud",0);
	addToSystemHudlist("weaponsHud", "T2 Weapons Hud", 0);
	addToSystemHudlist("clockHud", "T2 Clock Hud", 0);
	if($PJEnable::SuperHuds == 1) {
		if($PJPref::ExplodedCluster != 1){
			addToSystemHudlist("hudClusterBack", "T2 Compass Cluster", 0);
		} else removeFromSystemHudlist("hudClusterBack");
	}
	addToSystemHudlist("dashboardHud", "T2 Dashboard Hud", 0);
	addToSystemHudlist("NetGraphHudFrame", "T2 Network Graph Hud", 0);
	addToSystemHudlist("NetBarHudFrame", "T2 Network Bar Hud", 0);
	addToSystemHudlist("messageHud_Frame", "T2 Message Input", 1);
	addToSystemHudlist("MainVoteHud", "T2 Vote Hud", 1);
	if($PJScript::SuperChat != 1) {
		removeFromHudlist("outerChatHud");
		addToSystemHudlist("outerChatHud", "T2 Chat Hud", 0);
	}

	if(isObject(HM)) {
		for(%i = 1; %i <= $hudmover::scripthudnum; %i++) {
			%temp = $hudmover::scripthud[%i];

			if(%temp !$= "hudmover"){
				if(!PJisHud2($hudmover::scripthud[%i])) {
					$PJLabratHudCount++;
					$PJLabratHudList[$PJLabratHudCount] = %temp;
					$PJLabratHudName[$PJLabratHudCount] = $hudmover::scripthudname[%i];
					if($PJLabratHudMover[%temp] $= "")
						$PJLabratHudMover[%temp] = $hudpos[%temp];
					$PJLabratHudResize[%temp] = 1;
				}
			}
		}
	}

	if(isActivePackage(hudmover1))
		deactivatepackage(hudmover1);

	$PJHudFirstTime = 1;
}

function PJBuildOtherHudList(){

     $PJOtherHudCount = 0;
     for(%i = 0; %i < playgui.getcount(); %i++){

          %hudname = playgui.getobject(%i).getname();
//error(%hudname);
          if(!PJisHud(%hudname) && !PJisHud2(%hudname) && !PJisHud3(%hudname) && !PJisHud4(%hudname)){
          	$PJOtherHudCount++;
          	$PJOtherHudList[$PJOtherHudCount] = %hudname;
          	$PJOtherHudName[$PJOtherHudCount] = %hudname;
          	$PJOtherHudResize[%hudname] = 1;
//error("added: "@%hudname);
          }
     }
	PJHudmoverData.otherhudsbuilt = 1;
	$PJOtherHudResizeTR2BonusHud = 0;
}

function addToHudlist(%hudname, %displayname) {

	for(%i = 1; %i <= $PJHudCount; %i++) {
		if(%hudname $= $PJHudList[%i]) {
			return;
		}
	}

	$PJHudCount++;
	$PJHudList[$PJHudCount] = %hudname;
	$PJHudName[$PJHudCount] = %displayname;

echo(%hudname@" added");
}

function removeFromHudlist(%hudname) {

	for(%i = 1; %i <= $PJHudCount; %i++) {

		if(%hudname $= $PJHudList[%i]) {
			doHudlistRemove(%i);
			return;
		}
	}
echo("Removed Hud: "@%hudname);
}

function doHudlistRemove(%location) {

	for(%i = %location; %i <= $PJHudCount; %i++) {
		$PJHudList[%i] = $PJHudList[%i + 1];
		$PJHudName[%i] = $PJHudName[%i + 1];
	}

	$PJHudList[%i] = "";
	$PJHudName[%i] = "";
	$PJHudCount--;

echo("New Hud Count: "@$PJHudCount);
//for(%i = 1; %i <= $PJHudCount; %i++)
//	echo("Hud: "@$PJHudList[%i]);
}

function addToSystemHudlist(%hudname, %displayname, %type) {

	if($PJHudFirstTime == 0){
		if($PJSystemHudMover[%hudname] !$= ""){
			$PJSystemHudMoved[%hudname] = 1;
		}else{
			$PJSystemHudMoved[%hudname] = 0;
		}
	}

	if($PJHudMover[%hudname] !$= ""){
		$PJSystemHudMover[%hudname] = $PJHudMover[%hudname];
		$PJHudMover[%hudname] = "";
		$PJSystemHudExtent[%hudname] = $PJHudExtent[%hudname];
		$PJHudExtent[%hudname] = "";
		$PJSystemHudResize[%hudname] = $PJHudResize[%hudname];
		$PJHudResize[%hudname] = "";
		$PJSystemHudMoved[%hudname] = 0;
	}

	for(%i = 1; %i <= $PJHudCount; %i++) {
		if(%hudname $= $PJSystemHudList[%i]) {
			return;
		}
	}

	$PJSystemHudCount++;
	$PJSystemHudList[$PJSystemHudCount] = %hudname;
	$PJSystemHudName[$PJSystemHudCount] = %displayname;
	$PJSystemHudResize[%hudname] = %type;

error(%hudname@" added");
}

function removeFromSystemHudlist(%hudname) {

	for(%i = 1; %i <= $PJSystemHudCount; %i++) {

		if(%hudname $= $PJSystemHudList[%i]) {
			doSystemHudlistRemove(%i);
			return;
		}
	}
echo("Removed Hud: "@%hudname);
}

function doSystemHudlistRemove(%location) {

     %temp = $PJSystemHudList[%location];

	for(%i = %location; %i <= $PJSystemHudCount; %i++) {
		$PJSystemHudList[%i] = $PJSystemHudList[%i + 1];
		$PJSystemHudName[%i] = $PJSystemHudName[%i + 1];
	}

	$PJSystemHudList[%i] = "";
	$PJSystemHudName[%i] = "";
	$PJSystemHudResize[%temp] = "";
	$PJSystemHudCount--;

echo("New Hud Count: "@$PJHudCount);
//for(%i = 1; %i <= $PJHudCount; %i++)
//	echo("Hud: "@$PJHudList[%i]);
}

function PJisHud(%hud) {

     for(%i = 1; %i <= $PJHudCount; %i++) {
          if(%hud $= $PJHudList[%i])
               return true;
     }

     return false;
}

function PJisHud2(%hud) {

     for(%i = 1; %i <= $PJLabratHudCount; %i++) {
          if(%hud $= $PJLabratHudList[%i])
               return true;
     }

     return false;
}

function PJisHud3(%hud) {

     for(%i = 1; %i <= $PJSystemHudCount; %i++) {
          if(%hud $= $PJSystemHudList[%i])
               return true;
     }

     return false;
}

function PJisHud4(%hud) {

     if(PJHudmoverData.exclusion[%hud] == 1)
          return true;

     for(%i = 1; %i <= $PJOtherHudCount; %i++) {
          if(%hud $= $PJOtherHudList[%i])
               return true;
     }

     return false;
}


function PJGetHudPositions() {

	if($PJPref::DefaultHudFile $= ""){
		$PJPref::DefaultHudFile = "PJHuds" @ getword($pref::Video::resolution, 0) @ ".hud";
		if(isFile("prefs/PJHuds" @ getword($pref::Video::resolution, 0) @ ".hud"))
			$PJPref::DefaultHudFile = "PJHuds" @ getword($pref::Video::resolution, 0) @ ".hud";
	}

	if(isfile("prefs/" @ $PJPref::DefaultHudFile)) {
		PJEvalFile("prefs/" @ $PJPref::DefaultHudFile);
	}

	$PJStartResolution = $pref::Video::resolution;
}

function PJCheckforLabrat(){

	$PJSystemHudCount = 0;

     if(!isfile("hudmover/hudmover.cs") && !isfile("scripts/UberGuy/HudManager.cs"))
          $PJPref::LabratOverride = 1;

//--- OBJECT WRITE BEGIN ---
new GuiControl(PJHudMoverDlg) {
	profile = "GuiModelessDialogProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";
          pane = "PJHud";

	new ShellPaneCtrl(PJHudMoverTitle) {
		profile = "ShellDlgPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "20 30";
		extent = "560 420";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "SELECT HUD TO MOVE";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";

		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "34 362";
			extent = "82 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "PJexithudmover();";
			helpTag = "0";
			text = "DONE";
			simpleStyle = "0";
		};
		new ShellTabButton(HM_PJHudTab) {
			profile = "ShellTabProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "19 46";
			extent = "108 38";
			minExtent = "48 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "PJHudMoverDlg.setPane(PJHud);";
			helpTag = "0";
			text = "PJ";
			longTextBuffer = "0";
			maxLength = "255";
				simpleStyle = "0";
		};
		new ShellTabButton(HM_SystemHudTab) {
			profile = "ShellTabProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "19 76";
			extent = "108 38";
			minExtent = "48 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "PJHudMoverDlg.setPane(SystemHud);";
			helpTag = "0";
			text = "SYSTEM";
			longTextBuffer = "0";
			maxLength = "255";
				simpleStyle = "0";
		};
		new ShellTabButton(HM_LabratHudTab) {
			profile = "ShellTabProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "19 106";
			extent = "108 38";
			minExtent = "48 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "PJHudMoverDlg.setPane(LabratHud);";
			helpTag = "0";
			text = "LABRAT";
			longTextBuffer = "0";
			maxLength = "255";
				simpleStyle = "0";
		};
		new ShellTabButton(HM_OtherHudTab) {
			profile = "ShellTabProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "19 136";
			extent = "108 38";
			minExtent = "48 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "PJHudMoverDlg.setPane(OtherHud);";
			helpTag = "0";
			text = "OTHER";
			longTextBuffer = "0";
			maxLength = "255";
				simpleStyle = "0";
		};

		new ShellTabFrame() {
			profile = "ShellTabFrameProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "127 31";
			extent = "254 368";
			minExtent = "254 26";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			isVertical = "1";
			useCloseButton = "0";
			edgeInset = "0";
		};
		new ShellFieldCtrl(HM_PJHudPane) {
			profile = "ShellFieldProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "138 42";
			extent = "397 346";
			minExtent = "16 18";
			visible = "0";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new ShellFancyArrayScrollCtrl() {
				profile = "ShellServerBrowserProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "4 46";
				extent = "386 291";
				minExtent = "24 52";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				fixedHorizontal = "0";
				vertSpacerBitmap = "gui/shll_vertspacer";
				horzSpacerBitmap = "gui/shll_horzspacer";

				new ShellFancyTextList(HM_PJHudList) {
					profile = "ShellBrowserListProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "0 0";
					extent = "386 8";
					minExtent = "8 20";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					altCommand = "HM_HudListonDblClick();";
					helpTag = "0";
					startScrollRegion = "0 0";
					headerBitmap = "gui/server_tabs";
					sortArrowBitmap = "gui/shll_sortarrow";
					fieldBase = "gui/shll_field";
					barBase = "gui/shll_bar";
					glowOffset = "4";
					rowHeight = "15";
					headerFontType = "Univers Condensed";
					headerFontSize = "16";
					headerFontColor = "8 19 6 255";
					headerFontColorHL = "25 68 56 255";
					separatorColor = "192 192 192 255";
					drawSeparators = "0";
					headerSort = "1";
					allowReposition = "0";
					noSelect = "0";
					allowColorChars = "1";
				};
			};

			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "-2 9";
				extent = "90 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "PJLoadHudPositions();";
				helpTag = "0";
				text = "Load Positions";
				simpleStyle = "0";
			};
			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "center";
				vertSizing = "bottom";
				position = "292 9";
				extent = "90 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "PJSaveHudPositions();";
				helpTag = "0";
				text = "Save Positions";
				simpleStyle = "0";
			};
			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "305 9";
				extent = "90 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "HM_HudListonDblClick();";
				helpTag = "0";
				text = "Move Hud";
				simpleStyle = "0";
			};
		};
		new ShellFieldCtrl(HM_SystemHudPane) {
			profile = "ShellFieldProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "138 42";
			extent = "397 346";
			minExtent = "16 18";
			visible = "0";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new ShellFancyArrayScrollCtrl() {
				profile = "ShellServerBrowserProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "4 46";
				extent = "386 291";
				minExtent = "24 52";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				fixedHorizontal = "0";
				vertSpacerBitmap = "gui/shll_vertspacer";
				horzSpacerBitmap = "gui/shll_horzspacer";

				new ShellFancyTextList(HM_SystemHudList) {
					profile = "ShellBrowserListProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "0 0";
					extent = "386 8";
					minExtent = "8 20";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					altCommand = "HM_HudListonDblClick();";
					helpTag = "0";
					startScrollRegion = "0 0";
					headerBitmap = "gui/server_tabs";
					sortArrowBitmap = "gui/shll_sortarrow";
					fieldBase = "gui/shll_field";
					barBase = "gui/shll_bar";
					glowOffset = "4";
					rowHeight = "15";
					headerFontType = "Univers Condensed";
					headerFontSize = "16";
					headerFontColor = "8 19 6 255";
					headerFontColorHL = "25 68 56 255";
					separatorColor = "192 192 192 255";
					drawSeparators = "0";
					headerSort = "1";
					allowReposition = "0";
					noSelect = "0";
					allowColorChars = "1";
				};
			};

			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "-2 9";
				extent = "90 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "PJLoadHudPositions();";
				helpTag = "0";
				text = "Load Positions";
				simpleStyle = "0";
			};
			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "center";
				vertSizing = "bottom";
				position = "292 9";
				extent = "90 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "PJSaveHudPositions();";
				helpTag = "0";
				text = "Save Positions";
				simpleStyle = "0";
			};
			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "305 9";
				extent = "90 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "HM_HudListonDblClick();";
				helpTag = "0";
				text = "Move Hud";
				simpleStyle = "0";
			};
		};
		new ShellFieldCtrl(HM_LabratHudPane) {
			profile = "ShellFieldProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "138 42";
			extent = "397 346";
			minExtent = "16 18";
			visible = "0";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new ShellFancyArrayScrollCtrl() {
				profile = "ShellServerBrowserProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "4 46";
				extent = "386 291";
				minExtent = "24 52";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				fixedHorizontal = "0";
				vertSpacerBitmap = "gui/shll_vertspacer";
				horzSpacerBitmap = "gui/shll_horzspacer";

				new ShellFancyTextList(HM_LabratHudList) {
					profile = "ShellBrowserListProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "0 0";
					extent = "386 8";
					minExtent = "8 20";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					altCommand = "HM_HudListonDblClick();";
					helpTag = "0";
					startScrollRegion = "0 0";
					headerBitmap = "gui/server_tabs";
					sortArrowBitmap = "gui/shll_sortarrow";
					fieldBase = "gui/shll_field";
					barBase = "gui/shll_bar";
					glowOffset = "4";
					rowHeight = "15";
					headerFontType = "Univers Condensed";
					headerFontSize = "16";
					headerFontColor = "8 19 6 255";
					headerFontColorHL = "25 68 56 255";
					separatorColor = "192 192 192 255";
					drawSeparators = "0";
					headerSort = "1";
					allowReposition = "0";
					noSelect = "0";
					allowColorChars = "1";
				};
			};

			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "-2 9";
				extent = "90 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "PJLoadHudPositions();";
				helpTag = "0";
				text = "Load Positions";
				simpleStyle = "0";
			};
			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "center";
				vertSizing = "bottom";
				position = "292 9";
				extent = "90 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "PJSaveHudPositions();";
				helpTag = "0";
				text = "Save Positions";
				simpleStyle = "0";
			};
			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "305 9";
				extent = "90 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "HM_HudListonDblClick();";
				helpTag = "0";
				text = "Move Hud";
				simpleStyle = "0";
			};
		};
		new ShellFieldCtrl(HM_OtherHudPane) {
			profile = "ShellFieldProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "138 42";
			extent = "397 346";
			minExtent = "16 18";
			visible = "0";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new ShellFancyArrayScrollCtrl() {
				profile = "ShellServerBrowserProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "4 46";
				extent = "386 291";
				minExtent = "24 52";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				fixedHorizontal = "0";
				vertSpacerBitmap = "gui/shll_vertspacer";
				horzSpacerBitmap = "gui/shll_horzspacer";

				new ShellFancyTextList(HM_OtherHudList) {
					profile = "ShellBrowserListProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "0 0";
					extent = "386 8";
					minExtent = "8 20";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					altCommand = "HM_HudListonDblClick();";
					helpTag = "0";
					startScrollRegion = "0 0";
					headerBitmap = "gui/server_tabs";
					sortArrowBitmap = "gui/shll_sortarrow";
					fieldBase = "gui/shll_field";
					barBase = "gui/shll_bar";
					glowOffset = "4";
					rowHeight = "15";
					headerFontType = "Univers Condensed";
					headerFontSize = "16";
					headerFontColor = "8 19 6 255";
					headerFontColorHL = "25 68 56 255";
					separatorColor = "192 192 192 255";
					drawSeparators = "0";
					headerSort = "1";
					allowReposition = "0";
					noSelect = "0";
					allowColorChars = "1";
				};
			};

			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "-2 9";
				extent = "90 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "PJLoadHudPositions();";
				helpTag = "0";
				text = "Load Positions";
				simpleStyle = "0";
			};
			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "center";
				vertSizing = "bottom";
				position = "292 9";
				extent = "90 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "PJSaveHudPositions();";
				helpTag = "0";
				text = "Save Positions";
				simpleStyle = "0";
			};
			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "305 9";
				extent = "90 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "HM_HudListonDblClick();";
				helpTag = "0";
				text = "Move Hud";
				simpleStyle = "0";
			};
		};
	};
};
//--- OBJECT WRITE END ---

	HM_PJHudList.ClearColumns();
	HM_SystemHudList.ClearColumns();
	HM_LabratHudList.ClearColumns();
	HM_OtherHudList.ClearColumns();

	HM_PJHudList.addColumn( 0, "HUDNAME", 185, 185, 240,"left");
	HM_PJHudList.addColumn( 1, "RESIZABLE", 45, 45, 45,"center");
	HM_PJHudList.addColumn( 2, "MOVABLE", 40, 40, 40,"center");
	HM_PJHudList.addColumn( 3, "VISIBLE", 30, 30, 30,"center");
	HM_PJHudList.addColumn( 4, "GHOST", 30, 30, 30,"center");

	HM_SystemHudList.addColumn( 0, "HUDNAME", 185, 185, 240,"left");
	HM_SystemHudList.addColumn( 1, "RESIZABLE", 45, 45, 45,"center");
	HM_SystemHudList.addColumn( 2, "MOVABLE", 40, 40, 40,"center");
	HM_SystemHudList.addColumn( 3, "VISIBLE", 30, 30, 30,"center");
	HM_SystemHudList.addColumn( 4, "GHOST", 30, 30, 30,"center");

	HM_LabratHudList.addColumn( 0, "HUDNAME", 185, 185, 240,"left");
	HM_LabratHudList.addColumn( 1, "RESIZABLE", 45, 45, 45,"center");
	HM_LabratHudList.addColumn( 2, "MOVABLE", 40, 40, 40,"center");
	HM_LabratHudList.addColumn( 3, "VISIBLE", 30, 30, 30,"center");
	HM_LabratHudList.addColumn( 4, "GHOST", 30, 30, 30,"center");

	HM_OtherHudList.addColumn( 0, "HUDNAME", 185, 185, 240,"left");
	HM_OtherHudList.addColumn( 1, "RESIZABLE", 45, 45, 45,"center");
	HM_OtherHudList.addColumn( 2, "MOVABLE", 40, 40, 40,"center");
	HM_OtherHudList.addColumn( 3, "VISIBLE", 30, 30, 30,"center");
	HM_OtherHudList.addColumn( 4, "GHOST", 30, 30, 30,"center");


   // Add the popup menu:
   new GuiControl(HudMousePopupDLG) {
      profile = "GuiModelessDialogProfile";
      horizSizing = "width";
      vertSizing = "height";
      position = "0 0";
      extent = "640 480";
      minExtent = "8 8";
      visible = "1";
      setFirstResponder = "0";
      modal = "1";

      new ShellPopupMenu( HudMousePopup ) {
         profile = "ShellPopupProfile";
         position = "0 0";
         extent = "0 0";
         minExtent = "0 0";
         visible = "1";
         maxPopupHeight = "200";
         noButtonStyle = "1";
      };
   };

new GuiControl(PJHudLoadDlg) {
	profile = "GuiModelessDialogProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	helpTag = "0";

	new ShellPaneCtrl() {
		profile = "ShellDlgPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "147 142";
		extent = "345 295";
		minExtent = "48 92";
		visible = "1";
		helpTag = "0";
		text = "Load Hud File";
		noTitleBar = "0";

		new ShellScrollCtrl() {
			profile = "NewScrollCtrlProfile";
			horizSizing = "center";
			vertSizing = "top";
			position = "31 34";
			extent = "218 211";
			minExtent = "24 52";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			willFirstRespond = "1";
			hScrollBar = "alwaysOff";
			vScrollBar = "dynamic";
			constantThumbHeight = "0";
			defaultLineHeight = "15";
			childMargin = "0 2";
			fieldBase = "gui/shll_field";

			new GuiScrollContentCtrl() {
				profile = "GuiDefaultProfile";
				horizSizing = "center";
				vertSizing = "center";
				position = "4 6";
				extent = "210 209";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";

				new ShellTextList(PJHudFileList) {
					profile = "ShellTextArrayProfile";
					horizSizing = "center";
					vertSizing = "center";
					position = "0 0";
					extent = "210 8";
					minExtent = "8 8";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					altCommand = "Canvas.popDialog(PJHudLoadDlg);";
					helpTag = "0";
					enumerate = "1";
					resizeCell = "1";
					columns = "0";
					fitParentWidth = "1";
					clipColumnText = "0";
				};
			};
		};

		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "35 245";
			extent = "120 38";
			minExtent = "32 38";
			visible = "1";
			command = "PJHudmoverData.loadname = \"\"; Canvas.popDialog(PJHudLoadDlg);";
         accelerator = "escape";
			helpTag = "0";
			text = "CANCEL";
			simpleStyle = "0";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "190 245";
			extent = "120 38";
			minExtent = "32 38";
			visible = "1";
			command = "Canvas.popDialog(PJHudLoadDlg);";
			helpTag = "0";
			text = "LOAD";
			simpleStyle = "0";
		};
	};
};


//--- OBJECT WRITE BEGIN ---
new GuiControl(PJHudSaveDlg) {
	profile = "GuiModelessDialogProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	helpTag = "0";

	new ShellPaneCtrl() {
		profile = "ShellDlgPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "134 64";
		extent = "372 240";
		minExtent = "48 92";
		visible = "1";
		helpTag = "0";
		text = "Save Hud File";
		noTitleBar = "0";

		new ShellPopupMenu(PJHudListing) {
			profile = "ShellPopupProfile";
			horizSizing = "center";
			vertSizing = "top";
			position = "50 50";
			extent = "205 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Save as";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		new GuiMLTextCtrl(PJHudText) {
			profile = "ShellMediumTextProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "54 85";
			extent = "236 200";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
		};

		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "30 175";
			extent = "70 38";
			minExtent = "32 38";
			visible = "1";
			command = "Canvas.popDialog(PJHudSaveDlg);";
			helpTag = "0";
			text = "CANCEL";
			simpleStyle = "0";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "center";
			vertSizing = "top";
			position = "194 175";
			extent = "128 38";
			minExtent = "32 38";
			visible = "1";
			command = "Canvas.popDialog(PJHudSaveDlg); PJdohudsave(PJHudmoverData.savename);";
			helpTag = "0";
			text = "OVERWRITE";
			simpleStyle = "0";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "270 175";
			extent = "70 38";
			minExtent = "32 38";
			visible = "1";
			command = "Canvas.popDialog(PJHudSaveDlg); Canvas.pushDialog(PJHudSaveNameDlg);";
			helpTag = "0";
			text = "NEW";
			simpleStyle = "0";
		};
	};
};
//--- OBJECT WRITE END ---

     PJHudText.setText("<just:center>Select a Hud File to overwrite and click OVERWRITE or click NEW to create a new Hud file.");

//--- OBJECT WRITE BEGIN ---
new GuiControl(PJHudSaveNameDlg) {
	profile = "GuiModelessDialogProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl() {
		profile = "ShellDlgPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "155 175";
		extent = "330 130";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Enter File Description";
		maxLength = "255";
		noTitleBar = "0";

		new ShellTextEditCtrl(HudSaveName) {
			profile = "NewTextEditProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "28 35";
			extent = "273 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			altCommand = "Canvas.popDialog(PJHudSaveNameDlg); CheckHudName();";
			helpTag = "0";
			maxLength = "150";
			historySize = "0";
			password = "0";
			tabComplete = "0";
			deniedSound = "InputDeniedSound";
			glowOffset = "9 9";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "center";
			vertSizing = "top";
			position = "187 75";
			extent = "100 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "Canvas.popDialog(PJHudSaveNameDlg); CheckHudName();";
			helpTag = "0";
			text = "DONE";
			simpleStyle = "0";
		};
	};
};
//--- OBJECT WRITE END ---
}

function PJLoadHudPositions(){

          Canvas.pushDialog(PJHudLoadDlg);
}

function PJHudLoadDlg::onWake(%this){

	PJHudFileList.clear();

	%path = "prefs/PJHuds*";
	%total = 0;
	for( %file = findFirstFile( %path ); %file !$= ""; %file = findNextFile( %path ) ) {
		%name = getSubStr(filebase(%file), 6, 100);
		PJHudFileList.addrow(%total, %name);
		%total++;
	}

	PJHudFileList.sort(increasing);
	PJHudFileList.setSelectedRow(0);

}

function PJHudLoadDlg::onSleep(%this){

	if(PJHudmoverData.loadname !$= ""){
		$PJPref::DefaultHudFile = "PJHuds" @ PJHudmoverData.loadname @ ".hud";
		PJReloadHuds();
		clientCmdBottomPrint("\nMoving Huds for  " @ PJHudmoverData.loadname @ " - Please Wait", 4, 3);
		PJHudMoverTitle.setValue(PJHudmoverData.loadname  @ " Loaded");
	}
}

function PJHudFileList::onSelect(%this, %id, %text){

     PJHudmoverData.load = %id;
     PJHudmoverData.loadname = %text;
}

function PJSaveHudPositions(){

          Canvas.pushDialog(PJHudSaveDlg);
}

function PJHudSaveDlg::onWake(%this) {

     PJHudListing.clear();

	%path = "prefs/PJHuds*";
	%total = 0;
	for( %file = findFirstFile( %path ); %file !$= ""; %file = findNextFile( %path ) ) {
		%name = getSubStr(filebase(%file), 6, 100);
		PJHudListing.add(%name, %total);
		if(filebase(%file) $= filebase($PJPref::DefaultHudFile)){
			%selected = %total;
			PJHudmoverData.savename = %name;
		}
		%total++;
	}
error (%selected);
	PJHudListing.setSelected( %selected);
}

function PJHudListing::onSelect( %this, %id, %text ) {

     PJHudmoverData.save = %id;
     PJHudmoverData.savename = %text;
error(%text);
}

function CheckHudName(){

     %text = HudSaveName.getValue();

     if(%text $= "")
          PJHudmoverData.savenew = PJHudmoverData.savenew;
     else PJHudmoverData.savenew = %text;

     PJdohudsave(PJHudmoverData.savenew);
}

function PJdohudsave(%name) {
error(%name);
	%name = strreplace(%name, "PJHuds", "");
	%name = strreplace(%name, ".hud", "");
error(%name);
	$PJPref::DefaultHudFile = "PJHuds" @ %name @ ".hud";
	export("$PJHudFirstTime", "prefs/" @ $PJPref::DefaultHudFile, False);
	export("$PJHudMover*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJHudExtent*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJHudResize*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJHudMovable*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJHudVisible*", "prefs/" @ $PJPref::DefaultHudFile, True);

	export("$PJSystemHudMover*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJSystemHudExtent*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJSystemHudResize*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJSystemHudMoved*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJSystemHudMovable*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJSystemHudVisible*", "prefs/" @ $PJPref::DefaultHudFile, True);

	export("$PJLabratHudMover*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJLabratHudExtent*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJLabratHudResize*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJLabratHudMovable*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJLabratHudVisible*", "prefs/" @ $PJPref::DefaultHudFile, True);

	export("$PJOtherHudMover*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJOtherHudExtent*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJOtherHudResize*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJOtherHudMovable*", "prefs/" @ $PJPref::DefaultHudFile, True);
	export("$PJOtherHudVisible*", "prefs/" @ $PJPref::DefaultHudFile, True);

	clientCmdBottomPrint("\nSaved  " @ %name, 4, 3);
	PJHudMoverTitle.setValue(%name @ " Loaded");
}

if(!isfile("hudmover/hudmover.cs")){
     if (!isObject(HM)){

          new GuiControl(HM) {
          	profile = "GuiModelessDialogProfile";
          	horizSizing = "width";
          	vertSizing = "height";
          	position = "0 0";
          	extent = "640 480";
          	minExtent = "8 8";
          	visible = "1";
             	modal = "1";
          	bypassHideCursor = "1";
          	setFirstResponder = "0";

          	new ShellFieldCtrl(HudMover) {
          		profile = "ShellFieldProfile";
          		horizSizing = "right";
              		vertSizing = "bottom";
          		position = $hudpos[HudMover];
          		extent = "280 283";
          		minExtent = "16 18";
          		visible = "1";
          		helpTag = "0";
               };
          };
     }
}


$PJLabratHudCount = 0;
$PJHudMoverouterChatHud = "8 8";
$PJHudResizeouterChatHud = 0;
$PJHudMoverHudMoverDlg = mfloor(getword($pref::Video::resolution, 0) / 2) - 125 @ " 10";
$PJHudResizeHudMoverDlg = 0;
$PJHudFirstTime = 0;

$PJHudCount++;
$PJHudList[$PJHudCount] = "HudMoverDlg";
$PJHudName[$PJHudCount] = "Hud Mover: PJ Hud Mover Info";
$PJAddSystemHuds = 0;

$PJHudResize = 0;

$PJPref::LabratOverride = 0;
$PJPref::DefaultHudFile = "";


