
// #name = Tribes 2 Options Screen
// #version = 7.02
// #date = February 14, 2003
// #author =Mark Dickenson ([AKA]PanamaJack)
// #email = akapanamajack@wildmail.com
// #web = http://www.planetstarsiege.com/pj
// #description = Change PJ Script Options.
// #acknowledgements = none
// #status = work in progress

$PJVersion::Options = "7.02";

//if(!isObject(PJOptionList))
//    new ScriptObject(PJOptionList){};
//
//PJOptionList.scriptcount++;
//PJOptionList.author[PJOptionList.scriptcount] = "";
//
//PJOptionList.guipath[PJOptionList.scriptcount] = "scripts/autoexec/panamajack/gui/pjgeneral.gui";
//PJOptionList.preloadgui[PJOptionList.scriptcount] = 1;
//
//PJOptionList.selectcommand[PJOptionList.scriptcount] = "Canvas.pushDialog(PJCommunityOptionDlg);";
//PJOptionList.listtext[PJOptionList.scriptcount] = "Community";
//PJOptionList.readmepath[PJOptionList.scriptcount] = "scripts/autoexec/panamajack/readme/general.txt";
//
//PJOptionList.enablevariable[PJOptionList.scriptcount] = "";
//PJOptionList.activate[PJOptionList.scriptcount] = "addCommunity";
//PJOptionList.deactivate[PJOptionList.scriptcount] = "removeCommunity";
//
//PJOptionList.picturepath[PJOptionList.scriptcount] = "";
//
//PJOptionList.initialize[PJOptionList.scriptcount] = "";

if(!isObject(PJOptionList))
    new ScriptObject(PJOptionList){};

PJOptionList.scriptcount++;
PJOptionList.guipath[PJOptionList.scriptcount] = "";
PJOptionList.selectcommand[PJOptionList.scriptcount] = "";
PJOptionList.listtext[PJOptionList.scriptcount] = "PJ's Scripts Tab";
PJOptionList.readmepath[PJOptionList.scriptcount] = "scripts/autoexec/panamajack/readme/scripttab.txt";
PJOptionList.enablevariable[PJOptionList.scriptcount] = "";
PJOptionList.activate[PJOptionList.scriptcount] = "";
PJOptionList.deactivate[PJOptionList.scriptcount] = "";
PJOptionList.preloadgui[PJOptionList.scriptcount] = 0;
PJOptionList.picturepath[PJOptionList.scriptcount] = "panamajack/scripts/logo.jpg";
PJOptionList.author[PJOptionList.scriptcount] = "Panama Jack";

if(!isObject(PJPackageData))
    new ScriptObject(PJPackageData){};

function addpackage(%packagedfunction, %function, %beforeafter){

	PJPackageData.count[%packagedfunction @ %beforeafter]++;
	%temp = %packagedfunction @ %beforeafter @ PJPackageData.count[%packagedfunction @ %beforeafter];
	PJPackageData.funccall[%temp] = %function;
}

addpackage("DispatchLaunchMode", "DispatchLaunchModeScript", "before");
addpackage("DispatchLaunchMode", "DispatchLaunchModeScript2", "after");

function DispatchLaunchModeScript() {

	BuildPJOptions();

	for(%i = 1; %i <= PJOptionList.scriptcount; %i++) {
		if(PJOptionList.preloadgui[%i] == 1){
	     		exec(PJOptionList.guipath[%i]);
		}
	}
}

function DispatchLaunchModeScript2(){

	for(%i = 1; %i <= PJOptionList.scriptcount; %i++) {
		if(PJOptionList.initialize[%i] !$= ""){
     		call(PJOptionList.initialize[%i]);
		}
	}

	if(!$PlayingOnline)
		OP_PJUpdateBtn.setActive(0);

	if($PJVersion $= ""){
		$PJVersion = $PJVersion::Options;
		OP_PJUpdateBtn.setVisible(0);
	}

	if(isObject(autoload)){

		for(%i = 0; %i < autoload.loadedGroup.getCount(); %i++){
			%obj = autoload.loadedGroup.getObject(%i);
			%version = "";

			if(strlen(%obj.versionString) > 0)
				%version = " - " @ %obj.versionString;

			if(%obj.name !$= ""){
				PJOptionList.scriptcount++;
				PJOptionList.guipath[PJOptionList.scriptcount] = "";
				PJOptionList.config[PJOptionList.scriptcount] = %obj.config;
				PJOptionList.selectcommand[PJOptionList.scriptcount] = "";
				PJOptionList.listtext[PJOptionList.scriptcount] = %obj.name @ %version;
				PJOptionList.readmepath[PJOptionList.scriptcount] = %obj.readme;
				PJOptionList.enablevariable[PJOptionList.scriptcount] = "";
				PJOptionList.activate[PJOptionList.scriptcount] = "";
				PJOptionList.deactivate[PJOptionList.scriptcount] = "";
				PJOptionList.preloadgui[PJOptionList.scriptcount] = 0;
				PJOptionList.picturepath[PJOptionList.scriptcount] = "";
				if(%obj.author !$= "")
					PJOptionList.author[PJOptionList.scriptcount] = %obj.author;
				if(%obj.warrior !$= "")
					PJOptionList.author[PJOptionList.scriptcount] = %obj.warrior;
			}
		}

		for(%i = 0; %i < autoload.failedGroup.getCount(); %i++){

			%obj = autoload.failedGroup.getObject(%i);
			%version = "";

			if(strlen(%obj.versionString) > 0)
				%version = " - " @ %obj.versionString;

			if(%obj.name !$= ""){
				PJOptionList.scriptcount++;
				PJOptionList.guipath[PJOptionList.scriptcount] = "";
				PJOptionList.config[PJOptionList.scriptcount] = %obj.config;
				PJOptionList.selectcommand[PJOptionList.scriptcount] = "";
				PJOptionList.listtext[PJOptionList.scriptcount] = "Load Failed " @ %obj.name @ %version;
				PJOptionList.readmepath[PJOptionList.scriptcount] = %obj.readme;
				PJOptionList.enablevariable[PJOptionList.scriptcount] = "";
				PJOptionList.activate[PJOptionList.scriptcount] = "";
				PJOptionList.deactivate[PJOptionList.scriptcount] = "";
				PJOptionList.preloadgui[PJOptionList.scriptcount] = 0;
				PJOptionList.picturepath[PJOptionList.scriptcount] = "";
				if(%obj.author !$= "")
				PJOptionList.author[PJOptionList.scriptcount] = %obj.author;
				if(%obj.warrior !$= "")
				PJOptionList.author[PJOptionList.scriptcount] = %obj.warrior;
			}
		}
	}
}

addpackage("OptionsDlg::onWake", "PJScriptLists", "after");

function PJScriptLists(){

     OP_ScripterMenu.clear();
     OP_ScripterMenu.add("Everyone", 0);

     %count = 1;
	for(%i = 1; %i <= PJOptionList.scriptcount; %i++) {
          %found = 0;
          for(%ii = 0; %ii < %count; %ii++){
               if(OP_ScripterMenu.getTextbyId(%ii) $= PJOptionList.author[%i]){
                    %found = 1;
               }
          }
          if(!%found){
               OP_ScripterMenu.add(PJOptionList.author[%i], %count);
               %count++;
          }
	}

     OP_ScripterMenu.setSelected( 0 );

	OP_ScriptsList.clear();
	for(%i = 1; %i <= PJOptionList.scriptcount; %i++) {
    		OP_ScriptsList.addrow( %i, PJOptionList.listtext[%i]);
	}

	OP_ScriptsList.sort(increasing);
	OP_ScriptsList.setSelectedRow(0);

}

function OP_ScripterMenu::onSelect( %this, %id, %text ) {

	if(%text $= "Everyone"){
          PJScriptLists();
     }else{
          PJAuthorScriptLists(%text);
     }
}

function PJAuthorScriptLists(%author){

	OP_ScriptsList.clear();
	for(%i = 1; %i <= PJOptionList.scriptcount; %i++) {
          if(PJOptionList.author[%i] $= %author)
     		OP_ScriptsList.addrow( %i, PJOptionList.listtext[%i]);
	}

	OP_ScriptsList.sort(increasing);
	OP_ScriptsList.setSelectedRow(0);

}

function OP_ScriptsList::onSelect( %this, %id, %text ){

     if(isObject(OP_EnableTgl))
          OP_EnableTgl.delete();

			new ShellToggleButton(OP_EnableTgl) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "296 216";
				extent = "126 30";
				minExtent = "26 27";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "";
				helpTag = "0";
				text = "ENABLE SCRIPT";
				longTextBuffer = "0";
				maxLength = "255";
			};

     OP_EnableTgl.variable = PJOptionList.enablevariable[%id];
     OP_ScriptsPane.add(OP_EnableTgl);
     if(PJOptionList.enablevariable[%id] !$= ""){
          OP_EnableTgl.setActive(true);
     } else {
          OP_EnableTgl.setActive(false);
     }

     %readme = PJGetReadme(PJOptionList.readmepath[%id]);
     PJOptionsBodyText.setText(%readme);
     PJOptionsInfoTitle.setText(PJOptionList.listtext[%id]);

     if(%readme $= "")
          OP_ReadHelpBtn.setActive(false);
     else
          OP_ReadHelpBtn.setActive(true);

     OP_ScriptsList.id = %id;

     if(PJOptionList.preloadgui[%id] || PJOptionList.guipath[%id] $= ""){
          OP_OptionBtn.command = PJOptionList.selectcommand[%id];
          OP_ScriptsList.altCommand = PJOptionList.selectcommand[%id];
     } else {
          OP_OptionBtn.command = "exec(PJOptionList.guipath[" @ %id @ "]); " @ PJOptionList.selectcommand[%id];
          OP_ScriptsList.altCommand = "exec(PJOptionList.guipath[" @ %id @ "]); " @ PJOptionList.selectcommand[%id];
     }

     if(PJOptionList.config[%id] !$= ""){
          OP_OptionBtn.command = "PJDefaultOptions.gui = PJOptionList.config[" @ %id @ "]; SB_OptionsPane.remove(PJDefaultOptions.gui); PJOptionStore.add(PJDefaultOptions.gui); canvas.pushDialog(PJDefaultOptions);";
          OP_ScriptsList.altCommand = "PJDefaultOptions.gui = PJOptionList.config[" @ %id @ "]; SB_OptionsPane.remove(PJDefaultOptions.gui); PJOptionStore.add(PJDefaultOptions.gui); canvas.pushDialog(PJDefaultOptions);";
     } 

     if(PJOptionList.selectcommand[%id] $= "" && PJOptionList.config[%id] $= "")
          OP_OptionBtn.setActive(false);
     else
          OP_OptionBtn.setActive(true);

     if(PJOptionList.picturepath[%id] $= "")
          PJScriptDisplay.setbitmap($ShellBackground);
     else
          PJScriptDisplay.setbitmap(PJOptionList.picturepath[%id]);

}

function PJDefaultOptions::onWake(%this){

//            SB_OptionsPane.remove(PJDefaultOptions.gui);
//PJOptionStore.add(PJDefaultOptions.gui);
            PJDefaultOptions.gui.onWake();
            PJDefaultOptions.gui.setVisible(1);
}

function PJDefaultOptions::onSleep(%this){

            PJDefaultOptions.gui.onSleep();
            PJDefaultOptions.gui.setVisible(0);
PJOptionStore.remove(PJDefaultOptions.gui);
            SB_OptionsPane.add(PJDefaultOptions.gui);
}
	
//------------------------------------------------------------------------------
function OP_EnableTgl::onAction( %this )
{
   %on = %this.getValue();
   if ( %on )
      call(PJOptionList.activate[OP_ScriptsList.id]);
   else
      call(PJOptionList.deactivate[OP_ScriptsList.id]);

}

function PJGetReadme(%filename) {

	%file = new FileObject();

	if(!%file.openForRead( %filename )) {
		%file.close();
		%file.delete();
		return "";
	}

	for(%i = 1; !%file.isEOF(); %i++) {
		%string = %string @ %file.readLine() @ "\n";
	}

	%file.close();
	%file.delete();
	return %string;
}

function BuildPJOptions() {

		new ShellTabButton(OP_ScriptsTab) {
			profile = "ShellTabProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "19 286";
			extent = "108 38";
			minExtent = "48 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "OptionsDlg.setPane(Scripts);";
			helpTag = "0";
			text = "SCRIPTS";
			longTextBuffer = "0";
			maxLength = "255";
				simpleStyle = "0";
		};

     %obj = OptionsDlg.getObject(0);
     %obj.add(OP_ScriptsTab);

		new ShellFieldCtrl(OP_ScriptsPane) {
			profile = "ShellFieldProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "138 42";
			extent = "437 346";
			minExtent = "16 18";
			visible = "0";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
				group = "Main";

			new ShellScrollCtrl() {
				profile = "NewScrollCtrlProfile";
				horizSizing = "right";
				vertSizing = "height";
				position = "2 36";
				extent = "290 303";
				minExtent = "24 52";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				willFirstRespond = "1";
				hScrollBar = "alwaysOn";
				vScrollBar = "alwaysOn";
				constantThumbHeight = "0";
				defaultLineHeight = "15";
				childMargin = "0 2";
				fieldBase = "gui/shll_field";

				new GuiScrollContentCtrl() {
					profile = "GuiDefaultProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "4 6";
					extent = "280 291";
					minExtent = "8 8";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";

					new ShellTextList(OP_ScriptsList) {
						profile = "ShellTextArrayProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "0 0";
						extent = "280 8";
						minExtent = "8 8";
						visible = "1";
						hideCursor = "0";
						bypassHideCursor = "0";
						altCommand = "OP_ScriptsListonDblClick();";
						helpTag = "0";
						enumerate = "0";
						resizeCell = "0";
//						columns = "2 150";
						fitParentWidth = "0";
						clipColumnText = "0";
					};
				};
			};

			new ShellFieldCtrl() {
				profile = "ShellFieldProfile";
				horizSizing = "right";
				vertSizing = "height";
				position = "295 10";
				extent = "135 53";
				minExtent = "16 18";
				visible = "1";
				helpTag = "0";

				new GuiTextCtrl() {
					profile = "ShellTextCenterProfile";
					horizSizing = "left";
					vertSizing = "bottom";
					position = "0 2";
					extent = "135 25";
					minExtent = "8 8";
					visible = "1";
					helpTag = "0";
					text = "Panama Jack's Scripting";
					maxLength = "255";
				};
				new GuiTextCtrl() {
					profile = "ShellTextCenterProfile";
					horizSizing = "left";
					vertSizing = "bottom";
					position = "0 18";
					extent = "135 20";
					minExtent = "8 8";
					visible = "1";
					helpTag = "0";
					text = "Support Version " @ $PJVersion;
					maxLength = "255";
				};
				new GuiTextCtrl() {
					profile = "ShellTextCenterProfile";
					horizSizing = "left";
					vertSizing = "bottom";
					position = "0 35";
					extent = "135 20";
					minExtent = "8 8";
					visible = "1";
					helpTag = "0";
					text = "(c) 2002 Mark Dickenson";
					maxLength = "255";
				};
			};

			new ShellFieldCtrl() {
				profile = "ShellFieldProfile";
				horizSizing = "right";
				vertSizing = "top";
				position = "297 75";
				extent = "130 98";
				minExtent = "16 18";
				visible = "1";
				helpTag = "0";

				new GuiChunkedBitmapCtrl(PJScriptDisplay) {
					profile = "GuiDefaultProfile";
					horizSizing = "width";
					vertSizing = "height";
					position = "0 0";
					extent = "130 98";
					minExtent = "8 8";
					visible = "1";
					helpTag = "0";
					bitmap = $ShellBackground;
					useVariable = "0";
				};
			};

			new GuiTextCtrl() {
				profile = "ShellTextRightProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "22 9";
				extent = "100 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "View Scripts from:";
				longTextBuffer = "0";
				maxLength = "255";
			};
			new ShellPopupMenu(OP_ScripterMenu) {
				profile = "ShellPopupProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "118 0";
				extent = "180 36";
				minExtent = "49 36";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Everyone";
				longTextBuffer = "0";
				maxLength = "255";
				maxPopupHeight = "200";
				buttonBitmap = "gui/shll_pulldown";
				rolloverBarBitmap = "gui/shll_pulldownbar_rol";
				selectedBarBitmap = "gui/shll_pulldownbar_act";
				noButtonStyle = "0";
			};

			new ShellBitmapButton(OP_PJUpdateBtn) {
				profile = "ShellButtonProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "292 178";
				extent = "140 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "PJUpdateCheck();";
				helpTag = "0";
				text = "PJ UPDATE CHECK";
				simpleStyle = "0";
			};
			new ShellBitmapButton(OP_OptionBtn) {
				profile = "ShellButtonProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "292 246";
				extent = "140 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "";
				helpTag = "0";
				text = "SET OPTIONS";
				simpleStyle = "0";
			};
			new ShellBitmapButton(OP_ReadHelpBtn) {
				profile = "ShellButtonProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "292 284";
				extent = "140 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "Canvas.pushDialog(PJOptionsInfo);";
				helpTag = "0";
				text = "READ HELP FILE";
				simpleStyle = "0";
			};
		};

     %obj.add(OP_ScriptsPane);


new GuiControl(PJDefaultOptions) {
	profile = "DlgBackProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	helpTag = "0";

	new ShellPaneCtrl(PJOptionsTitle) {
		profile = "ShellDlgPaneProfile";
		horizSizing = "width";
		vertSizing = "height";
		position = "20 36";
		extent = "600 408";
		minExtent = "48 92";
		visible = "1";
		helpTag = "0";
		text = "PJ Options";
		maxLength = "255";
		noTitleBar = "0";

		new ShellFieldCtrl(PJOptionStore) {
			profile = "ShellFieldProfile";
			horizSizing = "width";
			vertSizing = "height";
			position = "25 30";
			extent = "550 328";
			minExtent = "16 18";
			visible = "1";
			helpTag = "0";

		};

		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "center";
			vertSizing = "top";
			position = "340 358";
			extent = "145 38";
			minExtent = "32 38";
			visible = "1";
			command = "Canvas.popDialog(PJDefaultOptions);";
			helpTag = "0";
			text = "CLOSE";
			simpleStyle = "0";
		};
	};
};

new GuiControl(PJOptionsInfo) {
	profile = "DlgBackProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	helpTag = "0";

	new ShellPaneCtrl(PJOptionsInfoTitle) {
		profile = "ShellDlgPaneProfile";
		horizSizing = "width";
		vertSizing = "height";
		position = "20 36";
		extent = "600 408";
		minExtent = "48 92";
		visible = "1";
		helpTag = "0";
		text = "PJ Options";
		maxLength = "255";
		noTitleBar = "0";

		new ShellFieldCtrl() {
			profile = "ShellFieldProfile";
			horizSizing = "width";
			vertSizing = "height";
			position = "25 30";
			extent = "550 328";
			minExtent = "16 18";
			visible = "1";
			helpTag = "0";

			new ShellScrollCtrl() {
				profile = "NewScrollCtrlProfile";
				horizSizing = "width";
				vertSizing = "height";
				position = "0 0";
				extent = "548 328";
				minExtent = "24 52";
				visible = "1";
				helpTag = "0";
				willFirstRespond = "1";
				hScrollBar = "alwaysOff";
				vScrollBar = "alwaysOn";
				constantThumbHeight = "0";
				defaultLineHeight = "15";
				childMargin = "3 3";
				fieldBase = "gui/shll_field";

				new GuiScrollContentCtrl() {
					profile = "GuiDefaultProfile";
					horizSizing = "width";
					vertSizing = "height";
					position = "7 7";
					extent = "545 320";
					minExtent = "8 8";
					visible = "1";
					helpTag = "0";

					new GuiMLTextCtrl(PJOptionsBodyText) {
						profile = "PJOptionsMessageTextProfile";
						horizSizing = "width";
						vertSizing = "height";
						position = "0 0";
						extent = "520 315";
						minExtent = "8 8";
						visible = "1";
						helpTag = "0";
						lineSpacing = "2";
						allowColorChars = "0";
						maxChars = "-1";
					};
				};
			};
		};

		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "center";
			vertSizing = "top";
			position = "340 358";
			extent = "145 38";
			minExtent = "32 38";
			visible = "1";
			command = "Canvas.popDialog(PJOptionsInfo);";
			helpTag = "0";
			text = "CLOSE";
			simpleStyle = "0";
		};
	};
};

}


