
// #name = Tribes 2 Support
// #version = 7.16
// #date = April 10, 2003
// #author =Mark Dickenson ([AKA]PanamaJack)
// #email = akapanamajack@wildmail.com
// #web = http://www.planetstarsiege.com/pj
// #description = Support routines for my scripts
// #acknowledgements = none
// #status = working

$PJVersion = "7.16";

//
//	New Callback Triggers for Vehicle Mounting and Dismounting
//
//	I could have used the callbacks that are included in Writer Support package but they
//	took way too much code to do something so simple.  This single callback is much smaller
//	and gives even MORE information as to your location in the vehicle.  The callback is 
//	triggered when you enter or leave any position in any of the base vehicles.  You can 
//	also check at anytime to see if you are in a vehicle and the position using the 
//	getManagerVehicle() and getManagerPosition() functions.
//
//	'msgVehicleMode' - Returns the name of the vehicle entered and your position in the vehicle.
//
//	example:
//
//	addMessageCallback('msgVehicleMode', handleMyVehicle);
//
//	function handleMyVehicle(%msgType, %msgString, %vehType, %position) {
//	}
//
//	Here is the %vehType and %position tables of data sent.
//
//	%vehType	%position
//	--------	--------
//	None		None
//	Hoverbike	Pilot
//	Assault		Pilot, Gunner
//	MPB		Pilot
//	Shrike		Pilot
//	Bomber		Pilot, Bombardier, Tailgunner
//	HAPC		Pilot, Tailgunner, LeftRear, LeftFront, RightRear, RightFront
//
//	%vehType will be "None" when the client exits the vehicle.
//

//	removeMessageCallback(%msgType, %func) - this is the reverse of the addMessageCallback routine.
//			It will remove the callback function from the array and reorder it.
//

if(!isObject(PJOptionList))
    new ScriptObject(PJOptionList){};

PJOptionList.scriptcount++;
PJOptionList.guipath[PJOptionList.scriptcount] = "scripts/autoexec/panamajack/gui/pjgeneral.gui";
PJOptionList.selectcommand[PJOptionList.scriptcount] = "Canvas.pushDialog(PJGeneralOptionDlg);";
PJOptionList.listtext[PJOptionList.scriptcount] = "PJ's General Options - " @ $PJVersion;
PJOptionList.readmepath[PJOptionList.scriptcount] = "scripts/autoexec/panamajack/readme/general.txt";
PJOptionList.enablevariable[PJOptionList.scriptcount] = "";
PJOptionList.activate[PJOptionList.scriptcount] = "";
PJOptionList.deactivate[PJOptionList.scriptcount] = "";
PJOptionList.preloadgui[PJOptionList.scriptcount] = 1;
PJOptionList.picturepath[PJOptionList.scriptcount] = "panamajack/scripts/general.jpg";
PJOptionList.author[PJOptionList.scriptcount] = "Panama Jack";

PJOptionList.scriptcount++;
PJOptionList.guipath[PJOptionList.scriptcount] = "";
PJOptionList.selectcommand[PJOptionList.scriptcount] = "";
PJOptionList.listtext[PJOptionList.scriptcount] = "PJ's Update Text";
PJOptionList.readmepath[PJOptionList.scriptcount] = "scripts/autoexec/panamajack/readme/update.txt";
PJOptionList.enablevariable[PJOptionList.scriptcount] = "";
PJOptionList.activate[PJOptionList.scriptcount] = "";
PJOptionList.deactivate[PJOptionList.scriptcount] = "";
PJOptionList.preloadgui[PJOptionList.scriptcount] = 0;
PJOptionList.picturepath[PJOptionList.scriptcount] = "panamajack/scripts/logo.jpg";
PJOptionList.author[PJOptionList.scriptcount] = "Panama Jack";

PJOptionList.scriptcount++;
PJOptionList.guipath[PJOptionList.scriptcount] = "scripts/autoexec/panamajack/gui/pjstartup.gui";
PJOptionList.selectcommand[PJOptionList.scriptcount] = "canvas.PushDialog(PJStartupDlg);";
PJOptionList.listtext[PJOptionList.scriptcount] = "PJ's Startup Options";
PJOptionList.readmepath[PJOptionList.scriptcount] = "scripts/autoexec/panamajack/readme/startup.txt";
PJOptionList.enablevariable[PJOptionList.scriptcount] = "";
PJOptionList.activate[PJOptionList.scriptcount] = "";
PJOptionList.deactivate[PJOptionList.scriptcount] = "";
PJOptionList.preloadgui[PJOptionList.scriptcount] = 0;
PJOptionList.picturepath[PJOptionList.scriptcount] = "panamajack/scripts/logo.jpg";
PJOptionList.author[PJOptionList.scriptcount] = "Panama Jack";

if(!isObject(PJGlobalOption))
    new ScriptObject(PJGlobalOption){};

if(!isObject(PJPackageData))
    new ScriptObject(PJPackageData){};

function addpackage(%packagedfunction, %function, %beforeafter){

	PJPackageData.count[%packagedfunction @ %beforeafter]++;
	%temp = %packagedfunction @ %beforeafter @ PJPackageData.count[%packagedfunction @ %beforeafter];
	PJPackageData.funccall[%temp] = %function;
}

addpackage("DispatchLaunchMode", "DispatchLaunchModeSupport", "before");
addpackage("DispatchLaunchMode", "DispatchLaunchModeSupport2", "after");

function DispatchLaunchModeSupport() {

	PJGlobalOption.playguistarted = 0;

	if(PJGlobalOption.startup != 1){
		exec("prefs/PJClientSchemes.cs");
		exec("prefs/PJClientPrefs.cs");
		exec("prefs/PJClientColors.cs");
		exec("prefs/PJClientFonts.cs");
		exec("prefs/PJScripts.cs");
		exec("scripts/autoexec/panamajack/PJGuiProfiles.pj");
		PJGlobalOption.startup = 1;
	}

	PJMakeDamageTypes();

	PJEvalFile("panamajack/mods/PJRuleSet.list");
	PJEvalFile("panamajack/mods/PJGameType.list");
	PJEvalFile("panamajack/mods/PJMapList.list");

	PJGetHudPositions();

// General Events Auto Repair
	addMessageCallback('MsgRepairPackNotDamaged', PJResetWeapon);
	addMessageCallback('MsgRepairPackNoTarget', PJResetWeapon);
	addMessageCallback('MsgRepairPackSelfDone', PJResetWeapon);
	addMessageCallback('MsgRepairPackDone', PJResetWeapon);
	addMessageCallback('MsgRepairPackLostTarget', PJResetWeapon);
	addMessageCallBack('MsgLoadInfo', PJMissionCheck);
	addMessageCallBack('MsgDamagedByTeam', PJTeamDamageHealth);
	addMessageCallback('MsgLeaveMissionArea', PJLeaveMissionAreaAlarmMessage );
	addMessageCallback('LeaveMissionArea', PJLeaveMissionAreaAlarmMessage );
	addMessageCallback('MsgEnterMissionArea', PJEnterMissionAreaAlarmMessage );
	addMessageCallback('EnterMissionArea', PJEnterMissionAreaAlarmMessage );
}

function DispatchLaunchModeSupport2(){

	if($PJPref::FirstTime !$= $PJVersion) {
		Canvas.pushDialog(PJUpdateInfo);
		PJUpdateBodyText.setText("<just:center><Font:Univers Condensed:14><color:2cacb5>Something <color:d0c07c>CHANGED <color:2cacb5>on this Version<color:ffffff>" @ $PJVersion @ "<color:2cacb5>.\n\n<color:2cacb5>When you click CONTINUE Tribes 2 will be checked\n<color:2cacb5>for older PJ Scripts.  If any are found you will\n<color:2cacb5>be notified so\n<color:2cacb5> you can<color:ffffff> update<color:2cacb5> them before playing.\n\n<color:ffffff>http://www.planettribes.com/pj\n\n<color:dddddd>The following updates may or may not\npertain to the scripts you have installed.\nThis is information on the current\n" @ $PJVersion @ " version release.\n\n" @ PJGetReadme("scripts/autoexec/panamajack/readme/update.txt"));
	}else{

		if ( $PlayingOnline ){
			if(!$PJPref::ShowEmail)
				LaunchTabView.closeTab( EmailGui, 0);
				if(!$PJPref::ShowChat)
					LaunchTabView.closeTab( ChatGui, 0);
				if(!$PJPref::ShowBrowser)
					LaunchTabView.closeTab( TribeAndWarriorBrowserGui, 0);
			}else{
				if(!$PJPref::ShowTraining)
					LaunchTabView.closeTab( TrainingGui, 0);
		}

		PJBindGlobals();
		makenewpanoramagui();

	new ShellBitmapButton(QuitButton) {
		profile = "ShellButtonProfile";
		horizSizing = "left";
		vertSizing = "bottom";
		position = "513 -5";
		extent = "64 38";
		minExtent = "32 38";
		visible = "1";
		command = "lobbyshutdown();";
		helpTag = "0";
		text = "QUIT";
		simpleStyle = "0";
	};

     %obj = LobbyGui.getObject(0);
     %obj.add(QuitButton);


	new ShellBitmapButton(ClearControls) {
		profile = "ShellButtonProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "292 282";
		extent = "140 38";
		minExtent = "32 38";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		command = "MessageBoxOKCancel( \"Clear Control\", \"Clear the selected Control Keybind.\", \"OP_RemapList.onDeleteKey(OP_RemapList.foundrow);\" );";
		helpTag = "0";
		text = "CLEAR CONTROL";
		simpleStyle = "0";
	};

     OP_ControlsPane.add(ClearControls);

	if($PJPref::AutoUpdateCheck)
		PJCheckforNewUpdates();

	}
}

addpackage("StartSelectedDemo", "StartSelectedDemoSupport", "before");

function StartSelectedDemoSupport() {

	disablekitty();
	$PJDemoPlayback = 1;
	PJGlobalOption.demoplayback = 1;
}

addpackage("demoPlaybackComplete", "demoPlaybackCompleteSupport", "before");

function demoPlaybackCompleteSupport() {

	$PJDemoPlayback = 0;
	PJGlobalOption.demoplayback = 0;
}

addpackage("stopDemoPlayback", "stopDemoPlaybackSupport", "before");

function stopDemoPlaybackSupport() {

	$PJDemoPlayback = 0;
	PJGlobalOption.demoplayback = 0;
}

addpackage("clientCmdSetAmmoHudCount", "stopDemoPlaybackSupport", "after");

function clientCmdSetAmmoHudCount(%amount){

     if($PJPref::WeaponSwitch){
          if(%amount == 0)
               nextweapon(1);
     }
}

function lobbyshutdown(){

     lobbyDisconnect();
     if(isObject($IRCClient.tcp))
          IRCClient::quit();
     LaunchTabView.closeAllTabs();
     quit();
}

addpackage("DisconnectedCleanup", "DisconnectedCleanupSupport", "before");
addpackage("DisconnectedCleanup", "DisconnectedCleanupSupport2", "after");

function DisconnectedCleanupSupport() {

     LaunchTabView.secondtime = 0;
}

function DisconnectedCleanupSupport2(){

	echo("Disconnected Clearing Team List");
	PJTeam::Reset();

     $BasePlusLoad = 0;
     $BasePlusLoad2 = 0;

     PJGlobalOption.playguistarted = 0;
	PJGlobalOption.playguifirsttime = 0;
}

addpackage("quit", "quitSupport", "before");

function quitSupport() {

	export("$PJpref::*", "prefs/PJClientPrefs.cs", False);
	echo("Saved PJ Prefs");

     if($PJPref::DeleteDSOs){
     	%count = 0;

     	for(%file = findFirstFile("*.dso"); %file !$= ""; %file = findNextFile("*.dso")) {
     		%filename[%count] = %file;
               %count++;
     	}

     	for (%i=0; %i < %count; %i++) {
     		deleteFile(%filename[%i]);
     	}
     }
DisconnectedCleanup();
}

function disablekitty(){

     if($PJVersion::Kitty $= "1.00"){
          cancel($kitty);
          cancel($kittystart);
          canvas.popDialog(KittyDlg);
     }
}

addpackage("LoadingGui::onWake", "LoadingGuionWakeSupport", "before");

function LoadingGuionWakeSupport(%this) {

     disablekitty();

     LaunchTabView.secondtime = 0;

	$CurrentPlayerTag = getField( wonGetAuthInfo(), 1);
}

addpackage("OptionsDlg::onSleep", "OptionsDlgonSleepSupport", "after");

function OptionsDlgonSleepSupport(%this) {

     PJModDamageTypes($PJRuleSet);

	export("$PJscheme::*", "prefs/PJClientSchemes.cs", false);
	export("$PJpref::*", "prefs/PJClientPrefs.cs", false);
	export("$PJColor::*", "prefs/PJClientColors.cs", false);
	export("$PJEnable::*", "prefs/PJScripts.cs", false);
	export("$PJFonts::*", "prefs/PJClientFonts.cs", false);
	echo("Saved PJ Prefs");

}

addpackage("ClientCmdDisplayHuds", "ClientCmdDisplayHudsSupport", "after");

function ClientCmdDisplayHudsSupport(){

	if(strlen($PJVersion::Compass) != 0){
		if($PJPref::CompassType == 1){
			if(isObject(PJCompassHud))
				PJCompassHud.setVisible(0);
		}

		if($PJPref::CompassType == 3) {
			PJCompassHud.setVisible(0);
			switch$ ($HudMode){
				case "Pilot":

					PJCompassHud.setVisible(1);

				case "Passenger":

					PJCompassHud.setVisible(1);

				case "Observer":

					PJCompassHud.setVisible(1);

				case "Object":

					PJCompassHud.setVisible(1);

				default:

					PJCompassHud.setVisible(1);
			}
		}

		if($PJPref::CompassType == 2) {
			HeatHud.minExtent = $PJSystemHudExtentHeatHud;
			damageHud.minExtent = $PJSystemHudExtentdamageHud;
			energyHud.minExtent = $PJSystemHudExtentenergyHud;

			HeatHud.resize(getword($PJSystemHudMoverHeatHud, 0), getword($PJSystemHudMoverHeatHud, 1), getword($PJSystemHudExtentHeatHud, 0), getword($PJSystemHudExtentHeatHud, 1));
			damageHud.resize(getword($PJSystemHudMoverdamageHud, 0), getword($PJSystemHudMoverdamageHud, 1), getword($PJSystemHudExtentdamageHud, 0), getword($PJSystemHudExtentdamageHud, 1));
			energyHud.resize(getword($PJSystemHudMoverenergyHud, 0), getword($PJSystemHudMoverenergyHud, 1), getword($PJSystemHudExtentenergyHud, 0), getword($PJSystemHudExtentenergyHud, 1));

			HeatHud.position = $PJSystemHudMoverHeatHud;
			damageHud.position = $PJSystemHudMoverdamageHud;
			energyHud.position = $PJSystemHudMoverenergyHud;
			newsensor.position = $PJSystemHudMovernewsensor;
			compassHud.position = $PJSystemHudMovercompassHud;

			HeatHud.extent = $PJSystemHudExtentHeatHud;
			damageHud.extent = $PJSystemHudExtentdamageHud;
			energyHud.extent = $PJSystemHudExtentenergyHud;

			HeatHud.subRegion = "0 0 " @ $PJSystemHudExtentHeatHud;
			damageHud.subRegion = "0 0 " @ $PJSystemHudExtentdamageHud;
			energyHud.subRegion = "0 0 " @ $PJSystemHudExtentenergyHud;

			if($PJPref::ShowCompassBorder){
				hudCompassBack.position = getword($PJSystemHudMovercompassHud, 0) + 2 SPC getword($PJSystemHudMovercompassHud, 1);
			}

			if($PJPref::BarBorder){
				HeatHudb.position = getword($PJSystemHudMoverHeatHud, 0) - 1 SPC getword($PJSystemHudMoverHeatHud, 1) - 1;
				damageHudb.position = getword($PJSystemHudMoverdamageHud, 0) - 1 SPC getword($PJSystemHudMoverdamageHud, 1) - 1;
				energyHudb.position = getword($PJSystemHudMoverenergyHud, 0) - 1 SPC getword($PJSystemHudMoverenergyHud, 1) - 1;
				HeatHudb.extent = getword($PJSystemHudExtentHeatHud, 0) + 2 SPC getword($PJSystemHudExtentHeatHud, 1) + 1;
				damageHudb.extent = getword($PJSystemHudExtentdamageHud, 0) + 2 SPC getword($PJSystemHudExtentdamageHud, 1) + 1;
				energyHudb.extent = getword($PJSystemHudExtentenergyHud, 0) + 2 SPC getword($PJSystemHudExtentenergyHud, 1) + 1;
			}

			PJCompassHud.setVisible(0);
			HeatHudb.setVisible(0);
			damageHudb.setVisible(0);
			energyHudb.setVisible(0);

			switch$ ($HudMode){
				case "Pilot":

					HeatHudb.setVisible(1);
					damageHudb.setVisible(1);
					energyHudb.setVisible(1);

				case "Passenger":

					HeatHudb.setVisible(1);
					damageHudb.setVisible(1);
					energyHudb.setVisible(1);

				case "Observer":

					HeatHudb.setVisible(1);
					damageHudb.setVisible(1);
					energyHudb.setVisible(1);

				case "Object":

					HeatHudb.setVisible(1);
					damageHudb.setVisible(1);
					energyHudb.setVisible(1);

				default:

					HeatHudb.setVisible(1);
					damageHudb.setVisible(1);
					energyHudb.setVisible(1);
			}
		}
	}

	if(strlen($PJVersion::ObjectiveHud) != 0){
		if($PJEnable::Objectivehud == 1){
			if($PJPref::Objectivehudtype == 0 || PJobjectivehud.gameType $= "SinglePlayerGame") {
				if($PJPref::TeamCountTransparent || $PJPref::ObjectiveBar == 0){
					objectiveHud.setSeparators("");
					objectiveHud.disableHorzSeparator();
				}

				if($PJPref::TeamCountHudDocked == 1) {
					%xpos = 0;
					if($PJPref::ObsHud) {
						ObsCountHud.position = %xpos @ " " @ getword(objectiveHud.position, 1);
						$PJHudMoverObsCountHud =  %xpos @ " " @ getword(objectiveHud.position, 1);
						%xpos = %xpos + 30;
					}
					TeamCountHud.position = %xpos @ " " @ getword(objectiveHud.position, 1);
					$PJHudMoverTeamCountHud = %xpos @ " " @ getword(objectiveHud.position, 1);
					%xpos = %xpos + 30;
					objectiveHud.position = %xpos @ " " @ getword(objectiveHud.position, 1);
				} else {
					TeamCountHud.position = $PJHudMoverTeamCountHud;
					ObsCountHud.position = $PJHudMoverObsCountHud;
				}

				if(isObject(PJobjectiveHud))
					PJobjectiveHud.setVisible(0);

			}else{
				PJObjectiveHud.setVisible(0);
				switch$ ($HudMode){
					case "Pilot":

						PJObjectiveHud.setVisible(1);

					case "Passenger":

						PJObjectiveHud.setVisible(1);

					case "Observer":

						PJObjectiveHud.setVisible(1);

					case "SiegeHalftime":

						PJObjectiveHud.setVisible(1);

					default:

						PJObjectiveHud.setVisible(1);
				}
			}
		}else{
			if(isObject(PJObjectiveHud))
				PJObjectiveHud.setVisible(0);
		}
	}

	if(strlen($PJVersion::WepInv) != 0){
		if($PJEnable::WepInv == 1 && $PJScript::WepInv == 1){
			if($PJPref::ShowNewWepInv == 1) {
				PJInventoryFull.setVisible(0);
				PJInventoryHud.setVisible(0);
				PJWeaponFull.setVisible(0);
				PJWeaponHud.setVisible(0);
				switch$ ($HudMode){
					case "Passenger":
						if(PJInventoryHudData.fullpanel == 1)
							PJInventoryFull.setVisible(1);

						PJInventoryHud.setVisible(1);

						if(PJWeaponHudData.fullpanel == 1)
							PJWeaponFull.setVisible(1);

						PJWeaponHud.setVisible(1);
					default:
						if(PJInventoryHudData.fullpanel == 1)
							PJInventoryFull.setVisible(1);

						PJInventoryHud.setVisible(1);

						if(PJWeaponHudData.fullpanel == 1)
							PJWeaponFull.setVisible(1);

						PJWeaponHud.setVisible(1);
				}
			}
		}
	}

	if(strlen($PJVersion::SuperChat) != 0){
		PJClientCmdHudSChat();
	}

	if(strlen($PJVersion::HudMover) != 0){
		PJSetSystemHuds();
	}

	if(strlen($PJVersion::JoinAnnouncement) != 0){
		PJClientDisplayAnn();
	}

	if(strlen($PJVersion::SpeedHud) != 0){
		resizeSpeedHuds();
		schedule(500, 0, PJCmdDisSpeed);
	}

	if(strlen($PJVersion::SuperHuds) != 0){
		outerChatHud.position = $PJHudMoverouterChatHud;
	}

	if(strlen($PJVersion::Superstats) != 0){
		PJClientDispHudStats();
	}

	if(strlen($PJVersion::TeamHud) != 0){
		if($PJDemoPlayback || PJGlobalOption.demoplayback == 1){
			TeamHud.setVisible(0);
			return;
		}

		if($PJEnable::TeamHud == 1) {
			switch$ ($HudMode) {

				case "Pilot":
					TeamHud.setVisible(false);

				case "Passenger":
					TeamHud.setVisible(false);

				case "Object":
					TeamHud.setVisible($PJTeamHud::Toggle);
					PJTHudSet();

				case "Observer":
					TeamHud.setVisible(false);

				case "PickTeam":
					TeamHud.setVisible(false);

				default:
					TeamHud.setVisible($PJTeamHud::Toggle);
					PJTHudSet();
			}

		   	if($PJPref::TeamDockSystem == 1)
				schedule(200, 0, doFixTeamHuds);

		} else TeamHud.setVisible(false);
	}

	if(strlen($PJVersion::TimeHud) != 0){
		resizeTimeHud();
		PJClientDispHTime();
	}
}

addpackage("PlayGui::onWake", "PlayGuionWakeSupport", "before");
addpackage("PlayGui::onWake", "PlayGuionWakeSupport2", "after");

function PlayGuionWakeSupport(%this) {

	if(strlen($PJVersion::TeamHud) != 0){
		PJOptionDlgTH(%this);
	}

	LaunchTabView.secondtime = 0;

	disablekitty();

	PJGlobalOption.playguistarted = 1;

	if($PJStartResolution !$= $pref::Video::resolution)
		PJGetHudPositions();
}

function PlayGuionWakeSupport2(){

	PJUnbindGlobals();
	$BasePlusLoad = 0;
	$BasePlusLoad2 = 0;

	PJGlobalOption.playguifirsttime = 1;

	if(strlen($PJVersion::ObjectiveHud) != 0){
		if($PJEnable::Objectivehud == 1){
			if($PJPref::Objectivehudtype == 0 || PJobjectivehud.gameType $= "SinglePlayerGame") {
				if($PJPref::TeamCountTransparent || $PJPref::ObjectiveBar == 0){
					objectiveHud.setSeparators("");
					objectiveHud.disableHorzSeparator();
				}

				if($PJPref::TeamCountHudDocked == 1) {
					%xpos = 0;
					if($PJPref::ObsHud) {
						ObsCountHud.position = %xpos @ " " @ getword(objectiveHud.position, 1);
						$PJHudMoverObsCountHud =  %xpos @ " " @ getword(objectiveHud.position, 1);
						%xpos = %xpos + 30;
					}
					TeamCountHud.position = %xpos @ " " @ getword(objectiveHud.position, 1);
					$PJHudMoverTeamCountHud = %xpos @ " " @ getword(objectiveHud.position, 1);
					%xpos = %xpos + 30;
					objectiveHud.position = %xpos @ " " @ getword(objectiveHud.position, 1);
				} else {
					TeamCountHud.position = $PJHudMoverTeamCountHud;
					ObsCountHud.position = $PJHudMoverObsCountHud;
				}

				if(isObject(PJobjectiveHud))
					PJobjectiveHud.setVisible(0);
			}
		}
	}

	if(strlen($PJVersion::AmmoBar) != 0){
		clientCmdTogglePlayHudsammohud(1);
	}

	if(strlen($PJVersion::SuperChat) != 0){
		PJPlayWakeSChat(%this);
	}

	if(strlen($PJVersion::HudMover) != 0){
		PJSetSystemHuds();
	}

	if(strlen($PJVersion::JoinAnnouncement) != 0){
		PJClientDisplayAnn();
	}

	if(strlen($PJVersion::Superstats) != 0){
		PJClientDispHudStats();
	}

	if(strlen($PJVersion::TeamHud) != 0){
		schedule(1000, 0, PJPlayWakeTHA, %this);
	}

	if(strlen($PJVersion::TimeHud) != 0){
		PJPlayWakeTimeHud(%this);
		resizeTimeHud();
	}
}

addpackage("PlayGui::onSleep", "PJBindGlobals", "after");
addpackage("clientCmdsetRepairPackIconOn", "clientCmdsetRepairPackIconOnSupport", "after");

function clientCmdsetRepairPackIconOnSupport(){

	if(!$PJPref::AutoRepair)
		return;

	$PJRepairing = 1;
	PJmouseFire(1);
}

addpackage("clientCmdsetRepairPackIconOff", "clientCmdsetRepairPackIconOffSupport", "after");

function clientCmdsetRepairPackIconOffSupport(){

	if(!$PJPref::AutoRepair)
		return;

	$PJRepairing = 0;
	PJmouseFire(0);
	PJResetWeapon();
}

addpackage("clientCmdSetWeaponsHudActive", "clientCmdSetWeaponsHudActiveSupport", "before");
addpackage("clientCmdSetWeaponsHudActive", "clientCmdSetWeaponsHudActiveSupport2", "after");

function clientCmdSetWeaponsHudActiveSupport(%slot, %ret, %vis) {

	if($PJPref::AutoRepair) {
		if($PJRepairing) {
			$PJRepairing = 0;
			if($mvTriggerCount0 & 1)
				PJmouseFire(0);
		}
	}
}

function clientCmdSetWeaponsHudActiveSupport2(%slot, %ret, %vis){

	if(%slot != -1)
		$PJWeaponSlot = $WeaponNames[%slot];
}

package PJPackageLoadNew {

function resetGameState(){

	parent::resetGameState();

	if($DemoStatusMessage $= "T2TV"){
		$PJDemoPlayback = 1;
		PJGlobalOption.demoplayback = 1;
	}
}

function clientCmdTogglePlayHudsSupport(%val) {

	if($retoggleoff)
		%val = 0;

	parent::clientCmdTogglePlayHuds(%val);
}

function LaunchToolbarMenu::clear(%this){

	parent::clear(%this);
	$PJBarLine = 0;
}

function demoPlaybackUpdate(%curTime){

     parent::demoPlaybackUpdate(%curTime);

	%time = msToMinSec(%curTime);

	if(%time $= "00:01"){
		if($PJGameType $= "")
			$PJGameType = CTFGame;
		schedule(100, 0, setupdemoplaybackhuds);
	}
}

function OptionsDlg::applyGraphicChanges(%this) {

     parent::applyGraphicChanges(%this);

	PJGetHudPositions();
}

function PJoramaGui::onWake(%this) {

     playgui.remove(navhud);
     PJoramaGui.add(navhud);
     updateActionMaps();

     LaunchTabView.secondtime = 0;

	if($PJStartResolution !$= $pref::Video::resolution)
		PJGetHudPositions();

     parent::onWake(%this);

     PJUnbindGlobals();
}

function PJoramaGui::onSleep(%this) {

     PJoramaGui.remove(navhud);
     playgui.add(navhud);

     parent::onSleep(%this);

     PJBindGlobals();
}

function GMJ_Browser::onSelect( %this, %address ) {

     parent::onSelect( %this, %address );

     if($PJMoreBuddies)
          return;

	%info = GMJ_Browser.getServerInfoString();
	$PJRuleSet = strlwr(getRecord( %info, 2 )); //rule set - mod
	$PJGameType = getRecord( %info, 4 ); //game type
echo("Game Type: "@$PJGameType);
//echo("Rule Set: "@$PJRuleSet);

	if($PJRuleSet $= "base" || $PJRuleSet $= "variant" || $PJRuleSet $= "bwadmin" || $PJRuleSet $= "tac") {
		PJMakeDamageTypes();
	} else {
		PJModDamageTypes($PJRuleSet);
	}

	%notnew = 0;
	for(%i = 0; %i < $PJRuleSetTotal; %i++) {
		if($PJRuleSetList[%i] $= $PJRuleSet || $PJRuleSet $= "")
			%notnew = 1;
	}

     %fileobj = new FileObject();
     %fileobj.openForWrite("panamajack/mods/");
     %fileobj.close();
     %fileobj.delete();

	if(%notnew == 0) {
		$PJRuleSetList[$PJRuleSetTotal] = $PJRuleSet;
		$PJRuleSetTotal++;
		export("$PJRuleSetTotal", "panamajack/mods/PJRuleSet.list", False);
		export("$PJRuleSetList*", "panamajack/mods/PJRuleSet.list", True);
          echo("Saved new RuleSet List added: " @ $PJRuleSetTotal - 1 @ " : " @  $PJRuleSet);
	}

	%notnew = 0;
	for(%i = 0; %i < $PJGameTypeTotal; %i++) {
		if($PJGameTypeList[%i] $= $PJGameType || $PJGameType $= "")
			%notnew = 1;
	}

	if(%notnew == 0 || $PJGameTypeTotal == 0) {
		$PJGameTypeList[$PJGameTypeTotal] = $PJGameType;
		$PJGameTypeTotal++;
		export("$PJGameTypeTotal", "panamajack/mods/PJGameType.list", False);
		export("$PJGameTypeList*", "panamajack/mods/PJGameType.list", True);
          echo("Saved new GameType List added: " @ $PJGameTypeTotal - 1 @ " : " @  $PJGameType);
	}
}

function mousefire(%val) {

	if($PJRepairing){
		$PJRepairing = 0;
		PJResetWeapon();
	}
	parent::mousefire(%val);
}

function ShellGetLoadFilename( %title, %fileSpec, %validate, %callback ) {

	LOAD_LoadBtn.text = "LOAD";

     parent::ShellGetLoadFilename( %title, %fileSpec, %validate, %callback );
}

function clientCmdVehicleMount(){

	parent::clientCmdVehicleMount();

	for(%i = 1; %i <= PJGlobalOption.bindcount; %i++) {
     	passengerKeys.bind(getfield(moveMap.getBinding(PJGlobalOption.bindname[%i]),0), getfield(moveMap.getBinding(PJGlobalOption.bindname[%i]),1), PJGlobalOption.bindname[%i]);
     }
}


function LaunchTabView::onSelect( %this, %id, %text ){

	parent::onSelect( %this, %id, %text );

	if($PJVersion::Kitty $= "1.00"){
		cancel($kittystart);
		$kittystart = schedule(120000 + mfloor(getrandom() * 360000), 0, startKitty);

		if(PJGlobalOption.kittystarted == 1)
			schedule(500, 0, doKittywake);
	}
}

};

activatepackage(PJPackageLoadNew);


function PJBindGlobals() {

	for(%i = 1; %i <= PJGlobalOption.bindcount; %i++) {
     	GlobalActionMap.bind(getfield(moveMap.getBinding(PJGlobalOption.bindname[%i]),0), getfield(moveMap.getBinding(PJGlobalOption.bindname[%i]),1), PJGlobalOption.bindname[%i]);
     }
}

function PJUnbindGlobals() {

	for(%i = 1; %i <= PJGlobalOption.bindcount; %i++) {
          GlobalActionMap.unbind(getfield(moveMap.getBinding(PJGlobalOption.bindname[%i]),0), getfield(moveMap.getBinding(PJGlobalOption.bindname[%i]),1) );
     }
}

//
// Load and evaluate every line of the file
//

function PJEvalFile(%filename) {

	%file = new FileObject();
	%datablockfound = 0;

	if(!%file.openForRead(%filename)) {
		echo("Cant find " @ %filename);
		%file.close();
		%file.delete();
		return;
	}

	for(%i = 1; !%file.isEOF(); %i++) {
		%string = %file.readLine();
		eval(%string);
	}

	%file.close();
	%file.delete();

echo("Loaded " @ %filename);
}

function PJMissionCheck(%msgType, %msgString, %bitmapName, %mapName, %missionType) {

	if($BasePlusLoad == 0){
		$PJMapname = StripAll(detag(%mapName));
		$PJMapnameFull = detag(%mapName);
		$PJMissionType = StripAll(detag(%missionType));
		$PJMissionTypeFull = detag(%missionType);
		echo("Mission Type: "@$PJMissionType);

		%notnew = 0;
		for(%i = 0; %i < $PJGameTypeTotal; %i++) {
			if($PJGameTypeList[%i] $= detag(%missionType) || detag(%missionType) $= "")
				%notnew = 1;
		}

		if(%notnew == 0 || $PJGameTypeTotal == 0) {
			$PJGameTypeList[$PJGameTypeTotal] = detag(%missionType);
			$PJGameTypeTotal++;
			%fileobj = new FileObject();
			%fileobj.openForWrite("panamajack/mods/");
			%fileobj.close();
			%fileobj.delete();
			export("$PJGameTypeTotal", "panamajack/mods/PJGameType.list", False);
			export("$PJGameTypeList*", "panamajack/mods/PJGameType.list", True);
			echo("Saved new GameType added: " @ $PJGameTypeTotal @ " : " @  detag(%missionType));
		}

		%notnew = 0;
		for(%i = 0; %i < $PJMapTotal; %i++) {
			if($PJMapList[%i] $= $PJMapnameFull || $PJMapnameFull $= "")
				%notnew = 1;
		}

		if(%notnew == 0 || $PJMapTotal == 0) {
			$PJMapList[$PJMapTotal] = $PJMapnameFull;
			$PJMapTotal++;
			%fileobj = new FileObject();
			%fileobj.openForWrite("panamajack/mods/");
			%fileobj.close();
			%fileobj.delete();
			export("$PJMapTotal", "panamajack/mods/PJMapList.list", False);
			export("$PJMapList*", "panamajack/mods/PJMapList.list", True);
			echo("Saved new Map added: " @ $PJMapTotal @ " : " @  $PJMapnameFull);
		}

		if($PJPref::ShowLoadingName)
			schedule(3000, 0, PJMessagePopup);
		$BasePlusLoad = 1;
	}
}

$PJPref::ShowLoadingName = 1;

//------------------------------------------------------------------------------
// Message popup dialog:
//------------------------------------------------------------------------------
function PJMessagePopup()
{
   LoadingProgressTxt.setValue( "Loading: " @ $PJMapnameFull @ " - " @ $PJMissionTypeFull );
   DB_LoadingProgressTxt.setValue( "Loading: " @ $PJMapnameFull @ " - " @ $PJMissionTypeFull );
   Canvas.repaint();
}

function PJmouseFire(%val){

   $mvTriggerCount0 += (($mvTriggerCount0 & 1) == %val) ? 2 : 1;

}

function PJResetWeapon() {

	if(!$PJPref::AutoRepair)
		return;

	if($PJRepairing != 0) {
		if($mvTriggerCount0 & 1)
			PJmouseFire(0);
	}

	$PJRepairing = 0;

	switch$($PJWeaponSlot) {
		case "Blaster":
			useBlaster(1);
		case "Plasma":
			usePlasma(1);
		case "Chaingun":
			useChainGun(1);
		case "Disc":
			useDisc(1);
		case "GrenadeLauncher":
			useGrenadeLauncher(1);
		case "SniperRifle":
			useSniperRifle(1);
		case "ELFGun":
			useElfGun(1);
		case "Mortar":
			useMortar(1);
		case "MissileLauncher":
			useMissileLauncher(1);
		case "ShockLance":
			useShockLance(1);
		case "TargetingLaser":
			useTargetingLaser(1);
	}

}

function PJModDamageTypes(%ruleset) {

	if(isFile("panamajack/mods/" @ StripAll(%ruleset) @ ".damage")) {
          PJModData.delete();
          exec("panamajack/mods/" @ StripAll(%ruleset) @ ".damage");
          echo("Loaded " @ StripAll(%ruleset) @ " Damage Types");
     }else{
          PJModData.delete();
          new ScriptObject(PJModData){};
          PJModData.save("panamajack/mods/" @ StripAll(%ruleset) @ ".damage");
     }
}

function PJFixRuleSetName(%text) {
//echo("Old Text: " @ %text);
	for(%i=1;%i <= getField($PJstrcheck2,0);%i++) {
		%text = strreplace(%text, getField($PJstrcheck2,%i), "");
	}
//echo("New Text: "@%text);
	return %text;
}

function PJMakeDamageTypes() {

	if(isObject(PJModData))
		PJModData.delete();

	if(isFile("panamajack/mods/base.damage")){
		exec("panamajack/mods/base.damage");
		return;
	}

	if(isFile("panamajack/mods/PJRuleSet.dam"))
		renameFile("panamajack/mods/PJRuleSet.dam", "panamajack/mods/PJRuleSet.list");

	if(isFile("panamajack/mods/PJGameType.dam"))
		renameFile("panamajack/mods/PJGameType.dam", "panamajack/mods/PJGameType.list");

	new ScriptObject(PJModData){};

	%file = new FileObject();
	%datablockfound = 0;

	if(!%file.openForRead("scripts/damageTypes.cs")) {
		echo("Cant find DamageTypes.cs");
		%file.close();
		%file.delete();
		return;
	}

	for(%i = 1; !%file.isEOF(); %i++) {
		%string = %file.readLine();
		if(!%datablockfound) {
			if(StrStr(%string, "datablock") != -1) {
				%datablockfound = 1;
			} else {
	     			if(StrStr(%string, "DamageTypeText") != -1) {
					%string = getSubStr(%string, 16, 300);
					%pos = StrStr(%string, "]");
					%number = getSubStr(%string, 0, %pos);
					%string = getSubStr(%string, %pos + 5, strlen(%string) - (%pos + 7));
					eval("PJModData.damagetype[" @ %number @ "] = \"" @ %string @ "\";");
				}
			}
		}
	}

	%file.close();
	%file.delete();

	PJModData.save("panamajack/mods/base.damage");
	PJModData.save("panamajack/mods/base++.damage");
	PJModData.save("panamajack/mods/bwadmin.damage");
	PJModData.save("panamajack/mods/variant.damage");
	PJModData.save("panamajack/mods/tac.damage");
	echo("Loaded Base Damage Types");

	rebuildmodpaths();
	%count = 0;

    	for(%file = findFirstFile("panamajack/mods/*.dam"); %file !$= ""; %file = findNextFile("panamajack/mods/*.dam")) {
    		%filename[%count] = filebase(%file);
		%count++;
	}

	for (%ii=0; %ii < %count; %ii++) {
		PJModData.delete();
		new ScriptObject(PJModData){};

	     	%file = new FileObject();
	     	%file.openForRead("panamajack/mods/" @ %filename[%ii] @ ".dam");

	     	for(%i = 1; !%file.isEOF(); %i++) {
	     		%string = %file.readLine();
	     		if(StrStr(%string, "DamageTypeText") != -1) {
				%string = getSubStr(%string, 16, 300);
				%pos = StrStr(%string, "]");
				%number = getSubStr(%string, 0, %pos);
				%string = getSubStr(%string, %pos + 5, 100);
				%pos = StrStr(%string, "\"");
				%string = getSubStr(%string, 0, %pos);
				eval("PJModData.damagetype[" @ %number @ "] = \"" @ %string @ "\";");
			}
		}

		%file.close();
		%file.delete();

		PJModData.save("panamajack/mods/" @ %filename[%ii] @ ".damage");
		deleteFile("panamajack/mods/" @ %filename[%ii] @ ".dam");
	}

	PJModData.delete();
	exec("panamajack/mods/base.damage");
	rebuildmodpaths();
}

function expandedcolors(%color) {

	%temp = HexToDecimal(getSubStr(%color, 0, 2)) @ " " @ HexToDecimal(getSubStr(%color, 2, 2)) @ " " @ HexToDecimal(getSubStr(%color, 4, 2));
	return %temp;
}


function PJTeamDamageHealth() {

     if($PJPref::TeamDamageHealth) {
          addMessageHudLine("Team Damage: Health Kit Used");
          useRepairKit(1);
     }
}

$PJPref::TeamDamageHealth = 0;

function PJCheckforNewUpdates(){

     if(!$PlayingOnline)
          return;

	$pjupdatepath = "/pj/pjautoversionlist.txt";

	new TCPObject (PJUpdateTCP);

	PJUpdateTCP.connect ("www.planettribes.com:80");
}

function PJUpdateCheck() {

     if(!$PlayingOnline)
          return;

     OP_PJUpdateBtn.setActive(0);

	$pjupdatepath = "/pj/pjversionlist.txt";

	new TCPObject (PJUpdateTCP);

	PJUpdateTCP.connect ("www.planettribes.com:80");
}

function PJUpdateTCP::onConnected(%this) {

	$PJUpdateTCPFileObj = new FileObject();
	$PJUpdateTCPFileObj.openForWrite ("prefs/PJVersionCheck.cs");

//	%this.send ("GET /members/panamajack/pjversionlist.txt\r\nHost: 127.0.0.1\r\n");	
	%this.send ("GET " @ $pjupdatepath @ "\r\nHost: 127.0.0.1\r\n");	
}

function PJUpdateTCP::onDNSFailed(%this) {

	PJUpdateTCP.delete ();
     OP_PJUpdateBtn.setActive(1);
}

function PJUpdateTCP::onConnectFailed(%this) {

	PJUpdateTCP.delete ();
     OP_PJUpdateBtn.setActive(1);
}

function PJUpdateTCP::onDisconnect(%this) {

	if (isObject (PJUpdateTCP)) {
		PJUpdateTCP.delete ();
	}

	$PJUpdateTCPFileObj.close();
	$PJUpdateTCPFileObj.delete();

     exec("prefs/PJVersionCheck.cs");
     OP_PJUpdateBtn.setActive(1);
}

function PJUpdateTCP::onLine(%this, %line) {

		$PJUpdateTCPFileObj.writeLine (%line);
}


function PJGeneralOptionDlg::onWake(%this){

	PJAniDelaySet.clear();
     for(%i = 5; %i <= 100; %i++)
     	PJAniDelaySet.add( %i, %i);

	PJAniSpeedSet.clear();
     for(%i = 1; %i <= 20; %i++)
     	PJAniSpeedSet.add( %i, %i);

     PJAniDelaySet.setSelected($PJPref::AniSpeed);
     PJAniSpeedSet.setselected($PJPref::AniStep);
}

function PJAniDelaySet::onSelect(%this, %id, %text){

     $PJPref::AniSpeed = %id;
}

function PJAniSpeedSet::onSelect(%this, %id, %text){

     $PJPref::AniStep = %id;
}

function ClosingGeneralDone(){

          Canvas.popDialog(PJGeneralOptionDlg);
}

function PJLeaveMissionAreaAlarmMessage(%msgType, %msgString){

     if($PJPref::OOBAnnouncer){
     	%handle = alxCreateSource(AudioChat, "voice/Announcer/ANN.oob.WAV");
     	alxPlay(%handle);
     }
}

function PJEnterMissionAreaAlarmMessage(%msgType, %msgString){

     if($PJPref::OOBAnnouncer){
     	%handle = alxCreateSource(AudioChat, "voice/Announcer/ANN.ib.WAV");
     	alxPlay(%handle);
     }
}

$PJPref::OOBAnnouncer = 1;

function makenewpanoramagui(){

new GameTSCtrl(PJoramaGui) {
	profile = "GuiContentProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "1";
	bypassHideCursor = "0";
	helpTag = "0";
	beaconBaseTextureName = "gui/beacon_base";
	beaconTargetTextureName = "gui/crosshairs";
	beaconTargetPeriod = "4000";
	beaconsVisible = "1";
	enemyBeaconLineBeginColor = "0.000000 1.000000 0.000000 0.200000";
	enemyBeaconLineEndColor = "0.000000 1.000000 0.000000 0.800000";
	vehicleBeaconLineBeginColor = "1.000000 0.000000 0.000000 0.200000";
	vehicleBeaconLineEndColor = "1.000000 0.000000 0.000000 0.800000";
	friendBeaconLineBeginColor = "1.000000 1.000000 0.000000 0.200000";
	friendBeaconLineEndColor = "1.000000 1.000000 0.000000 0.800000";
	beaconLineWidth = "2.5";
	beaconTextYOffset = "14";
	showAlternateTarget = "0";
		frinedBeaconLineEndColor = "1 1 0 0.8";


};

}

function OP_RemapList::onSelect(%this, %id, %text){

     OP_RemapList.foundrow = %id;
}

function setupdemoplaybackhuds(){

	ClientCmdDisplayHuds();
}


function removeMessageCallback(%msgType, %func) {

	for(%i = 0; (%afunc = $MSGCB[%msgType, %i]) !$= ""; %i++) {

		if(%afunc $= %func) {
			doCallbackDelete(%msgtype, %i);
			return;
		}
	}
}

function doCallbackDelete(%msgType, %location) {

	for(%i = %location; $MSGCB[%msgType, %i] !$= ""; %i++) {
		$MSGCB[%msgType, %i] = $MSGCB[%msgType, %i + 1];
	}

	$MSGCB[%msgType, %i] = "";
}

$PJPref::AutoUpdateCheck = 0;
$PJPref::ShowEmail = 1;
$PJPref::ShowChat = 1;
$PJPref::ShowBrowser = 1;
$PJPref::ShowTraining = 1;
$PJPref::GeneralAnimation = 0;
$PJPref::GeneralAnimationStyle = 0;
$PJPref::GeneralAnimationSpeed = 10;
$PJPref::WeaponSwitch = 0;
$PJPref::AutoRepair = 1;
$PJPref::DeleteDSOs = 1;

$PJWebAdded = "false";
$PJRepairing = 0;
$PJLastPlayer = 999;
$PJHudMovRemap = "false";
$PJOptionsRemap = "false";
$PJNotepadRemap = "false";
$PJDemoPlayback = 0;

$PJTopicTime = 1;
$PJRuleSet = "base";

$PJRuleSetTotal = 2;
$PJRuleSetList0 = "base";
$PJRuleSetList1 = "variant";

$PJMapTotal = 0;
$PJGameTypeTotal = 0;
$PJPackageFirstTime = 0;

$BasePlusLoad = 0;
$BasePlusLoad2 = 0;

$PJstrcheck2 = "13\t_\t{\t}\t:\t<\t>\t*\t^\t~\t@\t%\t&\t/\t\\\t`\t\"";
$PJDebrief = 0;


